local T, C, L, G = unpack( Tukui )

TukuiAurasPlayerBuffs:ClearAllPoints()
TukuiAurasPlayerDebuffs:ClearAllPoints()

TukuiAurasPlayerBuffs:SetPoint( "TOPRIGHT", UIParent, -149, -2 )
TukuiAurasPlayerBuffs:SetAttribute( "wrapAfter", 17 )
TukuiAurasPlayerBuffs:SetAttribute( "xOffset", -33 )
TukuiAurasPlayerBuffs:SetAttribute( "wrapYOffset", -67.5 )

TukuiAurasPlayerDebuffs:SetPoint( "TOPRIGHT", UIParent, -149, -137 )
TukuiAurasPlayerDebuffs:SetAttribute( "wrapAfter", 17 )
TukuiAurasPlayerDebuffs:SetAttribute( "xOffset", -33 )

local HookFrames = {
	TukuiAurasPlayerBuffs,
	TukuiAurasPlayerDebuffs,
	TukuiAurasPlayerConsolidate,
}

local OnAttributeChanged = function( self )
	for i = 1, self:GetNumChildren() do
		local child = select( i, self:GetChildren() )

		if( child ) then
			child:CreateBorder(true, true)
			child:CreateShadow("Default")
		end

		if( child.Duration ) then
			child.Duration:SetFont( T.CreateFontString() )
			child.Duration:ClearAllPoints()
			child.Duration:SetPoint( "CENTER", 0, -8 )
			
		if C.auras.classictimer == false then
			child.Duration:Kill()
		end
	end
		
		if(child.Holder) then
		child.Holder:CreateBorder(true, true)
		child.Holder:CreateShadow("Default")
		end

		if( child.Count ) then
			child.Count:SetFont( T.CreateFontString() )
			child.Count:ClearAllPoints()
			child.Count:SetPoint( "TOP", 0, -4 )
		end
	end
end

for _, frame in pairs( HookFrames ) do
	frame:RegisterEvent( "PLAYER_ENTERING_WORLD" )
	frame:HookScript( "OnAttributeChanged", OnAttributeChanged )
	frame:HookScript( "OnEvent", OnAttributeChanged )
end