local T, C, L, G = unpack(Tukui)

local DataTextPosition = function(f, t, o)
	local tableft = TukuiTabsLeftBackground
	local tabright = TukuiTabsRightBackground
	
	if o >= 1 and o <= 20 then	
		if o == 10 then
			t:ClearAllPoints()
			t:SetParent(tableft)
			t:SetHeight(tableft:GetHeight())
			t:SetPoint("RIGHT", -30, 0)
		elseif o == 11 then
			t:ClearAllPoints()
			t:SetParent(tabright)
			t:SetHeight(tabright:GetHeight())
			t:SetPoint("RIGHT", -30, 0)
		end
	else
		-- hide everything that we don't use and enabled by default on tukui
		f:Hide()
		t:Hide()
		end
	end


local datatext = {
	"Guild",
	"Friends",
	"Gold",
	"FPS",
	"System",
	"Bags",
	"Gold",
	"Time",
	"Durability",
	"Heal",
	"Damage",
	"Power",
	"Haste",
	"Crit",
	"Avoidance",
	"Armor",
	"Currency",
	"Hit",
	"Mastery",
	"MicroMenu",
	"Regen",
	"Talent",
	"CallToArms",
}


for _, data in pairs(datatext) do
	local t = "TukuiStat"
	local frame = _G[t..data]
	local text = _G[t..data.."Text"]

	if frame and frame.Option then
		if C.general.pixelfont == true then
			text:SetFont(C.media.pixelfont, C.datatext.fontsize, "MONOCHROMEOUTLINE")
		else
			text:SetFont(C.media.font, C.datatext.fontsize, "THINOUTLINE")
		end
		DataTextPosition(frame, text, frame.Option)
	end
end

GameTooltip:SetTemplate( "Transparent" )