local T, C, L = unpack(Tukui)
local parent = TukuiPlayer
local stick

if T.myclass == "ROGUE" and T.myclass == "DRUID" and C.unitframes.movecombobar then
	parent = TukuiPlayer
	stick = true
end

if not parent or C.unitframes.classiccombo then return end

local buffs = parent.Buffs
local MAX_COMBO_POINTS = MAX_COMBO_POINTS

local function UpdateBuffs(self, points)
	if stick then return end
	
	if points and points > 0 then
		self:Show()
		
		-- update Y position of buffs
		if buffs then 
			buffs:ClearAllPoints() 
			buffs:SetPoint("BOTTOMLEFT", parent, "TOPLEFT", -2, 14)
		end
	else
		self:Hide()
		
		-- update Y position of buffs
		if buffs then 
			buffs:ClearAllPoints() 
			buffs:SetPoint("BOTTOMLEFT", parent, "TOPLEFT", -2, 4)
		end
	end
end

local function OnUpdate(self)
	local points
	
	if UnitHasVehicleUI("player") then
		points = GetComboPoints("vehicle", "target")
	else
		points = GetComboPoints("player", "target")
	end

	if points then
		-- update combos display
		for i = 1, MAX_COMBO_POINTS do
			if i <= points then
				self[i]:SetAlpha(1)
			else
				self[i]:SetAlpha(.2)
			end
		end
	end

	UpdateBuffs(self, points)
end

-- create the bar
TukuiCombo:Size(parent:GetWidth() - 9, 3)
TukuiCombo:ClearAllPoints()
TukuiCombo:Point("BOTTOMLEFT", parent, "TOPLEFT", 0, 7)
TukuiCombo:SetScript("OnEvent", OnUpdate)
TukuiCombo:CreateBackdrop("Default")
TukuiCombo:CreateBorder(true, true)
TukuiCombo.backdrop:CreateShadow("Default")

for i = 1, 5 do
	TukuiCombo[i]:Height(3)
	
	if i == 1 then
		TukuiCombo[i]:Width(244/5)
	else
		TukuiCombo[i]:Width(237/5 )
	end
end