local T, C, L, G = unpack(Tukui)

--Kill unecessary panels.
local kill_panel = {TukuiLineToPetActionBarBackground, TukuiLineToABLeft, TukuiLineToABRight, TukuiInfoLeftLineVertical, TukuiInfoRightLineVertical, TukuiCubeLeft, TukuiCubeRight, TukuiLineToABLeftAlt, TukuiLineToABRightAlt}
for _, panel in pairs(kill_panel) do
	panel:Kill()
end



--Action bars. 
TukuiBar1:ClearAllPoints()
TukuiBar1:SetPoint("BOTTOM", UIParent, "BOTTOM", 0, 2)
TukuiBar1:SetWidth((T.buttonsize * 12) + (T.buttonspacing * 13))
TukuiBar1:SetHeight((T.buttonsize * 2) + (T.buttonspacing * 3))
TukuiBar1:SetTemplate("Transparent")
TukuiBar1:CreateShadow("Default")
TukuiBar1:CreateBorder(true, true)

-- Bug fix, credit and a big thanks to Pat on Tukui.org. :3
TukuiBar1:SetTemplate("Transparent")
if TukuiBar4:IsShown() then
	TukuiBar1:SetHeight((T.buttonsize * 2) + (T.buttonspacing * 3))
end

TukuiBar4:HookScript("OnHide", function()
	TukuiBar1:SetHeight((T.buttonsize * 1) + (T.buttonspacing * 2))
end)

TukuiBar4:HookScript("OnShow", function()
	TukuiBar1:SetHeight((T.buttonsize * 2) + (T.buttonspacing * 3))
end)

TukuiBar2:Width((T.buttonsize * 6) + (T.buttonspacing * 7))
TukuiBar2:CreateBorder(true, true)
TukuiBar2:SetTemplate("Transparent")
TukuiBar2:CreateShadow("Default")

TukuiBar3:Width((T.buttonsize * 6) + (T.buttonspacing * 7))
TukuiBar3:CreateBorder(true, true)
TukuiBar3:SetTemplate("Transparent")
TukuiBar3:CreateShadow("Default")

TukuiBar4:ClearAllPoints()
TukuiBar4:Point("BOTTOM", TukuiBar1, "BOTTOM", -5, 0)
TukuiBar4:SetWidth((T.buttonsize * 12) + (T.buttonspacing * 10.3))
TukuiBar4:SetHeight((T.buttonsize * 2) + (T.buttonspacing * 3))
TukuiBar4:SetBackdrop(nil)
TukuiBar4:HideInsets()

TukuiBar5:ClearAllPoints()
TukuiBar5:SetHeight((T.buttonsize * 12) + (T.buttonspacing * 13))
TukuiBar5:Point("RIGHT", UIParent, "RIGHT", -2, -14)
TukuiBar5:SetTemplate("Transparent")
TukuiBar5:CreateBorder(true, true)
TukuiBar5:CreateShadow("Default")


TukuiBar6:SetBackdrop(nil)
TukuiBar6:SetHeight((T.buttonsize * 12) + (T.buttonspacing * 11))



TukuiBar7:SetBackdrop(nil)
TukuiBar7:SetHeight((T.buttonsize * 12) + (T.buttonspacing * 10.3))



TukuiPetBar:SetHeight((T.buttonsize * 10) + (T.buttonspacing * 11))
TukuiPetBar:SetTemplate("Transparent")
TukuiPetBar:CreateBorder(true, true)
TukuiPetBar:CreateShadow("Default")

TukuiLineToPetActionBarBackground:SetBackdrop(nil)


-- Datatext panels.
TukuiInfoLeft:ClearAllPoints()
TukuiInfoLeft:Point("BOTTOMLEFT", UIParent, "BOTTOMLEFT", 8, 8)
TukuiInfoLeft:SetFrameStrata("Background")
TukuiInfoLeft:SetTemplate("Default")
TukuiInfoLeft:CreateBorder(true, true)
TukuiInfoLeft:Height(23)
TukuiInfoLeft:CreateShadow("Default")

TukuiInfoRight:ClearAllPoints()
TukuiInfoRight:Point("BOTTOMRIGHT", UIParent, "BOTTOMRIGHT", -8, 8)
TukuiInfoRight:SetFrameStrata("Background")
TukuiInfoRight:SetTemplate("Transparent")
TukuiInfoRight:CreateBorder(true, true)
TukuiInfoRight:Height(23)
TukuiInfoRight:CreateBorder("Default")
TukuiInfoRight:CreateShadow("Default")

TukuiMinimapStatsLeft:ClearAllPoints()
TukuiMinimapStatsLeft:Point("TOPLEFT", TukuiBar1, "BOTTOMLEFT", 0, -3)
TukuiMinimapStatsLeft:Size(91, 23)
TukuiMinimapStatsLeft:CreateShadow("Default")
TukuiMinimapStatsLeft:Kill() -- Don't want it anymore.

TukuiMinimapStatsRight:ClearAllPoints()
TukuiMinimapStatsRight:Point("BOTTOM", TukuiMinimap, "BOTTOM", 0, -8)
TukuiMinimapStatsRight:SetTemplate("Default")
TukuiMinimapStatsRight:SetFrameStrata("HIGH")
TukuiMinimapStatsRight:CreateShadow("Default")

-- Battleground frames.
if C.datatext.battleground == true then
G.Panels.BattlegroundDataText:Size(TukuiInfoLeft:GetSize())
G.Panels.BattlegroundDataText:SetFrameLevel(TukuiInfoLeft:GetFrameLevel() + 1)
G.Panels.BattlegroundDataText:CreateShadow("Default")

-- Uhm.... Idk... Don't remove..? ;p
G.DataText.Battleground.Text1:SetFont(C.media.pixelfont, C.datatext.fontsize, "MONOCHROMEOUTLINE")
G.DataText.Battleground.Text1:SetShadowOffset(0, 0)
G.DataText.Battleground.Text2:SetFont(C.media.pixelfont, C.datatext.fontsize, "MONOCHROMEOUTLINE")
G.DataText.Battleground.Text2:SetShadowOffset(0, 0)
G.DataText.Battleground.Text3:SetFont(C.media.pixelfont, C.datatext.fontsize, "MONOCHROMEOUTLINE")
G.DataText.Battleground.Text3:SetShadowOffset(0, 0)
end

--Random chat thing. DO NOT REMOVE.
local ichat = CreateFrame("Frame", "ichat", TukuiInfoLeft)
ichat:SetTemplate("Default")
ichat:SetPoint("CENTER", TukuiInfoLeft, "CENTER", 0, 143)
ichat:Size(T.InfoLeftRightWidth, 23)
ichat:SetAlpha(0)

--Edit the chat frames. 
if C.chat.background == true then
TukuiChatBackgroundLeft:CreateBorder(true, true)
TukuiChatBackgroundLeft:SetFrameStrata("Background")
TukuiChatBackgroundLeft:CreateShadow("Default")
TukuiTabsLeftBackground:CreateShadow("Default")

TukuiChatBackgroundRight:CreateBorder(true, true)
TukuiChatBackgroundRight:SetFrameStrata("Background")
TukuiChatBackgroundRight:CreateShadow("Default")
TukuiTabsRightBackground:CreateShadow("Default")
end

TukuiRaidUtilityShowButton:Kill()