local T, C, L = unpack(Tukui)
if not IsAddOnLoaded("TinyDPS") then return end
if not C.general.tinydpsreskin then return end

local frame = CreateFrame("Frame")
frame:RegisterEvent("PLAYER_LOGIN")
frame:SetScript("OnEvent", function(self, event)	
	-- define our locals
	local frame = tdpsFrame
	local anchor = tdpsAnchor
	local status = tdpsStatusBar
	local tdps = tdps
	local font = tdpsFont
	local position = tdpsPosition
	local button = TukuiRaidUtilityShowButton
	
	-- set our default configuration
	if tdps then
		tdps.width = TukuiMinimap:GetWidth()
		tdps.spacing = 1
		tdps.barHeight = 16
		font.name = C["Fmedia"].Pixel_Font
		font.size = 12
		font.outline = "OUTLINEMONOCHROME"
	end
	
	-- set default position, under minimap
	anchor:ClearAllPoints()
	anchor:Point('BOTTOMLEFT', TukuiMinimap, 'BOTTOMLEFT', 0, -16)
	
	-- make sure width is applied, even if it was a first install
	frame:SetWidth(TukuiMinimap:GetWidth())
	
	-- needed, idk why
	position = {x = 0, y = 0}
	
	-- skin it
	frame:CreateBorder(true, true)
	frame:CreateShadow("Default")
	
	--Border for TinyDPS - Had some issues with the border so made this, was easier. :P
	local tdpsBG = CreateFrame("Frame", "tdpsBG", frame)
	tdpsBG:CreatePanel("Default", 1, 1, "CENTER", frame, "CENTER", 0, 0)
	tdpsBG:ClearAllPoints()
	tdpsBG:SetPoint("TOPLEFT", 2, -2)
	tdpsBG:SetPoint("BOTTOMRIGHT", -2, 2)
	tdpsBG:SetBackdropBorderColor(0, 0, 0, 0)
	tdpsBG:CreateBorder(false, true)
	tdpsBG:CreateShadow("Default")
	
	if status then
		tdpsStatusBar:SetBackdrop({bgFile = C["media"].normTex, edgeFile = C["media"].blank, tile = false, tileSize = 0, edgeSize = 1, insets = { left = 0, right = 0, top = 0, bottom = 0}})
		tdpsStatusBar:SetStatusBarTexture(C["media"].normTex)
	end
	
	-- move it a little bit if you are a raid leader because of TukuiRaidUtility button.
	if button then
		button:HookScript("OnShow", function(self) 
			anchor:ClearAllPoints()
			anchor:Point('BOTTOMLEFT', TukuiMinimap, 'BOTTOMLEFT', 0, -16)
		end)
		button:HookScript("OnHide", function(self) 
			anchor:ClearAllPoints()
			anchor:Point('BOTTOMLEFT', TukuiMinimap, 'BOTTOMLEFT', 0, -16)
		end)
		
		button:ClearAllPoints()
		button:SetPoint("TOPLEFT", UIParent, "TOPLEFT", 325, -3)
		
		TukuiRaidUtility:ClearAllPoints()
		TukuiRaidUtility:SetPoint("TOPLEFT", UIParent, "TOPLEFT", 325, -3)
end
end)