local T, C, L, G = unpack(Tukui)


------------------------------
-- Player
------------------------------
do
	------------------------------
	-- not needed
	------------------------------
	do
		G.UnitFrames.Player:SetBackdrop( nil )
		G.UnitFrames.Player:SetBackdropColor( 0, 0, 0 )
		G.UnitFrames.Player.shadow:Kill()
		G.UnitFrames.Player.panel:Kill()
	end

	------------------------------
	-- health
	------------------------------
	do
		G.UnitFrames.Player.Health:Height( 27 )
		G.UnitFrames.Player.Health:SetFrameLevel( 9 )
		G.UnitFrames.Player.Health:SetFrameStrata("LOW")
		G.UnitFrames.Player.Health:CreateBorder(false, true)
		G.UnitFrames.Player.Health.bg:SetTexture(.6, .5, .5)
		
		--Border for the health bar.
				local healthBG = CreateFrame("Frame", healthBG, G.UnitFrames.Player.Health)
				healthBG:ClearAllPoints()
				healthBG:SetPoint("TOPLEFT", -2, 2)
				healthBG:SetPoint("BOTTOMRIGHT", 2, -2)
				healthBG:Size(1, 1)
				healthBG:SetTemplate("Default")
				healthBG:CreateBorder(true, true)
				healthBG:CreateShadow("Default")
				healthBG:SetFrameStrata("Low")
				healthBG:SetFrameLevel(G.UnitFrames.Player.Health:GetFrameLevel())

		if( C["unitframes"]["unicolor"] == true ) then
			G.UnitFrames.Player.Health.colorTapping = false
			G.UnitFrames.Player.Health.colorDisconnected = false
			G.UnitFrames.Player.Health.colorClass = false
			G.UnitFrames.Player.Health:SetStatusBarColor( 0.12, 0.12, 0.12)
			G.UnitFrames.Player.Health.bg:SetVertexColor( .6, .3, .3, 1 )
		else
			G.UnitFrames.Player.Health.bg:SetVertexColor( .05, .05, .05, 1 )
			G.UnitFrames.Player.Health.colorDisconnected = true
			G.UnitFrames.Player.Health.colorTapping = true
			G.UnitFrames.Player.Health.colorClass = true
			G.UnitFrames.Player.Health.colorReaction = true
		end
		

		G.UnitFrames.Player.Health.value = T.SetFontString( G.UnitFrames.Player.Health, T.CreateFontString())
		G.UnitFrames.Player.Health.value:Point( "RIGHT", G.UnitFrames.Player.Health, "RIGHT", -4, 1 )
		G.UnitFrames.Player.Health.value:SetShadowOffset(0, 0)

		G.UnitFrames.Player.Health.PostUpdate = T.PostUpdateHealth
	end

	------------------------------
	-- power
	------------------------------
	do
		G.UnitFrames.Player.Power:Size( 240, 27 )
		G.UnitFrames.Player.Power:ClearAllPoints()
		G.UnitFrames.Player.Power:SetFrameLevel(1)
		G.UnitFrames.Player.Power:SetFrameStrata("Background")
		G.UnitFrames.Player.Power:Point( "BOTTOMRIGHT", G.UnitFrames.Player.Health, "BOTTOMRIGHT", 6, -6 )
		G.UnitFrames.Player.Power:CreateBorder(false, true)

		G.UnitFrames.Player.Power.value = T.SetFontString( G.UnitFrames.Player.Health, T.CreateFontString())
		G.UnitFrames.Player.Power.value:Point( "LEFT", G.UnitFrames.Player.Health, "LEFT", 4, 1 )
		G.UnitFrames.Player.Power.value:SetShadowOffset(0, 0)
		
		--Border for the powerbar.
				local powerBG = CreateFrame("Frame", powerBG, G.UnitFrames.Player.Power)
				powerBG:ClearAllPoints()
				powerBG:SetPoint("TOPLEFT", -2, 2)
				powerBG:SetPoint("BOTTOMRIGHT", 2, -2)
				powerBG:Size(1, 1)
				powerBG:SetTemplate("Default")
				powerBG:CreateBorder(true, true)
				powerBG:HideInsets()
				powerBG:CreateShadow("Default")
				powerBG:SetFrameStrata("Background")
				powerBG:SetFrameLevel(G.UnitFrames.Player.Power:GetFrameLevel())
	
	end

	------------------------------
	-- portraits
	------------------------------
	do
		if( C["unitframes"]["charportrait"] == true ) then
		
		if C.unitframes.integrateportrait == true then
			G.UnitFrames.Player.Portrait:ClearAllPoints()
			G.UnitFrames.Player.Portrait:SetPoint("TOPLEFT", G.UnitFrames.Player.Health, 0, -1)
			G.UnitFrames.Player.Portrait:SetPoint("BOTTOMRIGHT", G.UnitFrames.Player.Health, 0, 1)
			G.UnitFrames.Player.Portrait:SetAlpha( 0.2 )
			G.UnitFrames.Player.Portrait.SetAlpha = T.dummy
			G.UnitFrames.Player.Health:ClearAllPoints()
			G.UnitFrames.Player.Health:SetPoint( "TOPLEFT", 0, 0 )
			G.UnitFrames.Player.Health:SetPoint( "TOPRIGHT" )
		else
			G.UnitFrames.Player.Portrait:ClearAllPoints()
			G.UnitFrames.Player.Portrait:SetPoint("RIGHT", G.UnitFrames.Player.Health, "LEFT", -7, -3)
			G.UnitFrames.Player.Portrait:Size(60, G.UnitFrames.Player.Health:GetHeight() + 5)
			G.UnitFrames.Player.Portrait:SetFrameLevel( G.UnitFrames.Player.Health:GetFrameLevel() )
			G.UnitFrames.Player.Health:ClearAllPoints()
			G.UnitFrames.Player.Health:SetPoint( "TOPLEFT", 0, 0 )
			G.UnitFrames.Player.Health:SetPoint( "TOPRIGHT" )
			
			--Border for the portrait.
				local portraitBG = CreateFrame("Frame", portraitBG, G.UnitFrames.Player.Portrait)
				portraitBG:ClearAllPoints()
				portraitBG:SetPoint("TOPLEFT", -2, 2)
				portraitBG:SetPoint("BOTTOMRIGHT", 2, -3)
				portraitBG:Size(1, 1)
				portraitBG:SetTemplate("Transparent")
				portraitBG:CreateBorder(true, true)
				portraitBG:HideInsets()
				portraitBG:CreateShadow("Default")
				portraitBG:SetFrameStrata("Background")
				portraitBG:SetFrameLevel(G.UnitFrames.Player.Portrait:GetFrameLevel())
			end
		end
	end

	------------------------------
	-- combat icon
	------------------------------
	do
		G.UnitFrames.Player.Combat:Size( 14 )
		G.UnitFrames.Player.Combat:ClearAllPoints()
		G.UnitFrames.Player.Combat:SetPoint( "CENTER", 0, 0 )
		G.UnitFrames.Player.Combat:SetVertexColor( 0.69, 0.31, 0.31 )
	end

	------------------------------
	-- mana flash
	------------------------------
	do
		G.UnitFrames.Player.FlashInfo:ClearAllPoints()
		G.UnitFrames.Player.FlashInfo:SetAllPoints( G.UnitFrames.Player.Health )
		G.UnitFrames.Player.FlashInfo:SetFrameLevel( G.UnitFrames.Player.Health:GetFrameLevel() + 2 )

		G.UnitFrames.Player.FlashInfo.ManaLevel:ClearAllPoints()
		G.UnitFrames.Player.FlashInfo.ManaLevel:SetPoint( "CENTER", 0, 1 )
		G.UnitFrames.Player.FlashInfo.ManaLevel:SetFont(T.CreateFontString() )
		G.UnitFrames.Player.FlashInfo.ManaLevel:SetShadowOffset(0, 0)
		
	end

	------------------------------
	-- experience
	------------------------------
	do
		if( T.level ~= MAX_PLAYER_LEVEL ) then
			G.UnitFrames.Player.Experience:ClearAllPoints()
			G.UnitFrames.Player.Experience:SetStatusBarColor( 0, 0.4, 1, 0.8 )

			G.UnitFrames.Player.Experience:Size(TukuiTabsRightBackground:GetWidth() - 4, TukuiTabsRightBackground:GetHeight() - 4)
			G.UnitFrames.Player.Experience:Point("CENTER", TukuiTabsRightBackground, "CENTER", 0, 0)
			G.UnitFrames.Player.Experience:SetFrameLevel( 3 )
			G.UnitFrames.Player.Experience:SetAlpha( 0 )
			G.UnitFrames.Player.Experience:CreateBorder(false, true)

			G.UnitFrames.Player.Experience:HookScript( "OnLeave", function( self ) self:SetAlpha( 0 ) end )
			
		

			G.UnitFrames.Player.Resting:ClearAllPoints()
			G.UnitFrames.Player.Resting:Size(18)
			G.UnitFrames.Player.Resting:SetAlpha(0) -- Just hate that thing so I had to hide it...
			G.UnitFrames.Player.Resting:SetPoint( "TOPLEFT", G.UnitFrames.Player.Health, "TOPLEFT", -10, 10)
		end
	end

	------------------------------
	-- reputation
	------------------------------
	do
		if( T.level == MAX_PLAYER_LEVEL ) then
		G.UnitFrames.Player.Reputation:ClearAllPoints()
		
		G.UnitFrames.Player.Reputation:Size(TukuiTabsRightBackground:GetWidth() - 4, TukuiTabsRightBackground:GetHeight() - 4)
		G.UnitFrames.Player.Reputation:Point("CENTER", TukuiTabsRightBackground, "CENTER", 0, 0)
		G.UnitFrames.Player.Reputation:SetFrameLevel(3)
		G.UnitFrames.Player.Reputation:SetAlpha(0)
		G.UnitFrames.Player.Reputation:CreateBorder(false, true)
		
		G.UnitFrames.Player.Reputation:SetScript("OnLeave", function(self) self:SetAlpha(0) end)
		
		
		end
	end

	------------------------------
	-- combat feedback
	------------------------------
	do
		if( C["unitframes"]["combatfeedback"] == true ) then
			G.UnitFrames.Player.CombatFeedbackText:SetFont(T.CreateFontString() )
			G.UnitFrames.Player.CombatFeedbackText:SetShadowOffset(0, 0)
		end
	end

	------------------------------
	-- druidmana
	------------------------------
	do
		if( T.myclass == "DRUID" ) then
			G.UnitFrames.Player.DruidManaText:SetFont(T.CreateFontString())
		end
	end

	------------------------------
	-- classbar
	------------------------------
	do
		------------------------------
		-- druid
		------------------------------
	if( T.myclass == "DRUID" ) then
		if C.unitframes.druidmanabar == true then
			G.UnitFrames.Player.DruidManaBackground:ClearAllPoints()
			G.UnitFrames.Player.DruidManaBackground:SetPoint( "TOP", G.UnitFrames.Player, "TOP", 0, -2)
			G.UnitFrames.Player.DruidManaBackground:Size( 236, 2)
			G.UnitFrames.Player.DruidManaBackground:CreateBorder(false, true)

			G.UnitFrames.Player.DruidMana:SetSize( G.UnitFrames.Player.DruidManaBackground:GetWidth(), G.UnitFrames.Player.DruidManaBackground:GetHeight() )
			end

			
			-- Eclipse bar.
			G.UnitFrames.Player.EclipseBar:ClearAllPoints()
			G.UnitFrames.Player.EclipseBar:SetPoint( "BOTTOM", G.UnitFrames.Player, "TOP", 0, 7)
			G.UnitFrames.Player.EclipseBar:Size( 240, 3 )
			G.UnitFrames.Player.EclipseBar:CreateBorder(false, true)
			
			--Border for the classbar.
				local classBG = CreateFrame("Frame", classBG, G.UnitFrames.Player.EclipseBar)
				classBG:ClearAllPoints()
				classBG:SetPoint("TOPLEFT", -2, 2)
				classBG:SetPoint("BOTTOMRIGHT", 2, -2)
				classBG:Size(1, 1)
				classBG:SetTemplate("Default")
				classBG:CreateBorder(true, true)
				classBG:SetFrameStrata("Background")
				classBG:CreateShadow("Default")

			G.UnitFrames.Player.EclipseBar.LunarBar:SetSize( G.UnitFrames.Player.EclipseBar:GetWidth(), G.UnitFrames.Player.EclipseBar:GetHeight() )
			G.UnitFrames.Player.EclipseBar.SolarBar:SetSize( G.UnitFrames.Player.EclipseBar:GetWidth(), G.UnitFrames.Player.EclipseBar:GetHeight() )

			G.UnitFrames.Player.EclipseBar.Text:ClearAllPoints()
			G.UnitFrames.Player.EclipseBar.Text:SetPoint( "CENTER", G.UnitFrames.Player.Health, 0, 0 )
			G.UnitFrames.Player.EclipseBar.Text:SetFont(T.CreateFontString())
			
			
		
		if C.unitframes.mushroombar == true then	
			-- Mushroom bar.
				G.UnitFrames.Player.WildMushroom:ClearAllPoints()
				G.UnitFrames.Player.WildMushroom:SetPoint( "BOTTOMLEFT", G.UnitFrames.Player, "TOPLEFT", 0, 17 )
				G.UnitFrames.Player.WildMushroom:Size( 240, 3 )
				
				--Border for the mushroom bar.
				local mushroomBG = CreateFrame("Frame", mushroomBG, G.UnitFrames.Player.WildMushroom)
				mushroomBG:ClearAllPoints()
				mushroomBG:SetPoint("TOPLEFT", -2, 2)
				mushroomBG:SetPoint("BOTTOMRIGHT", 2, -2)
				mushroomBG:Size(1, 1)
				mushroomBG:SetTemplate("Default")
				mushroomBG:CreateBorder(true, true)
				mushroomBG:SetFrameStrata("Background")
				mushroomBG:CreateShadow("Default")
				
				for i = 1, 3 do
					

					if( i == 1 ) then
						G.UnitFrames.Player.WildMushroom[i]:Size( T.Scale(240 / 3) - 2, 3 )
						G.UnitFrames.Player.WildMushroom[i]:SetPoint( "LEFT", G.UnitFrames.Player.WildMushroom, "LEFT", 0, 0 )
					else
						G.UnitFrames.Player.WildMushroom[i]:Size( T.Scale(240 / 3), 3 )
						G.UnitFrames.Player.WildMushroom[i]:Point( "LEFT", G.UnitFrames.Player.WildMushroom[i - 1], "RIGHT", 1, 0 )
						end
					end
			else
				G.UnitFrames.Player.WildMushroom:Kill()
			end
		end

		------------------------------
		-- warlock
		------------------------------
		if( T.myclass == "WARLOCK" ) then
				G.UnitFrames.Player.WarlockSpecBars:ClearAllPoints()
				G.UnitFrames.Player.WarlockSpecBars:SetPoint( "BOTTOMLEFT", G.UnitFrames.Player, "TOPLEFT", 0, 7 )
				G.UnitFrames.Player.WarlockSpecBars:Size( 240, 3 )
				
				--Border for the classbar.
				local classBG = CreateFrame("Frame", classBG, G.UnitFrames.Player.WarlockSpecBars)
				classBG:ClearAllPoints()
				classBG:SetPoint("TOPLEFT", -2, 2)
				classBG:SetPoint("BOTTOMRIGHT", 2, -2)
				classBG:Size(1, 1)
				classBG:SetTemplate("Default")
				classBG:CreateBorder(true, true)
				classBG:SetFrameStrata("Background")
				classBG:CreateShadow("Default")

				for i = 1, 4 do
					G.UnitFrames.Player.WarlockSpecBars[i]:Size( T.Scale( 240 / 4 ), 3 )

					if( i == 1 ) then
						G.UnitFrames.Player.WarlockSpecBars[i]:SetPoint( "LEFT", G.UnitFrames.Player.WarlockSpecBars, "LEFT", 0, 0 )
					else
						G.UnitFrames.Player.WarlockSpecBars[i]:Point( "LEFT", G.UnitFrames.Player.WarlockSpecBars[i - 1], "RIGHT", 1, 0 )
					end
				end
			end

		------------------------------
		-- paladin
		------------------------------
		if( T.myclass == "PALADIN" ) then
			G.UnitFrames.Player.HolyPower:ClearAllPoints()
			G.UnitFrames.Player.HolyPower:SetPoint( "BOTTOM", G.UnitFrames.Player, "TOP", 0, 7 )
			G.UnitFrames.Player.HolyPower:Size( 240, 3 )
			G.UnitFrames.Player.HolyPower:CreateBorder(false, true)
			
			--Border for the classbar.
				local classBG = CreateFrame("Frame", classBG, G.UnitFrames.Player.HolyPower)
				classBG:ClearAllPoints()
				classBG:SetPoint("TOPLEFT", -2, 2)
				classBG:SetPoint("BOTTOMRIGHT", 2, -2)
				classBG:Size(1, 1)
				classBG:SetTemplate("Default")
				classBG:CreateBorder(true, true)
				classBG:SetFrameStrata("Background")
				classBG:CreateShadow("Default")

			for i = 1, 5 do
				G.UnitFrames.Player.HolyPower[i]:SetStatusBarColor( 228 / 255, 225 / 255, 16 / 255 )
				if( i == 5 ) then
					G.UnitFrames.Player.HolyPower[i]:Size( T.Scale( 240 / 5 ) - 4, 3 )
				else
					G.UnitFrames.Player.HolyPower[i]:Size( T.Scale( 240 / 5 ) , 3 )
				end

				if( i == 1 ) then
					G.UnitFrames.Player.HolyPower[i]:SetPoint( "LEFT", G.UnitFrames.Player.HolyPower )
				else
					G.UnitFrames.Player.HolyPower[i]:Point( "LEFT", G.UnitFrames.Player.HolyPower[i - 1], "RIGHT", 1, 0 )
				end
			end
		end
		
		------------------------------
		-- Mage.
		------------------------------
		if T.myclass == "MAGE" then
			G.UnitFrames.Player.ArcaneChargeBar:ClearAllPoints()
			G.UnitFrames.Player.ArcaneChargeBar:Point("BOTTOMLEFT", G.UnitFrames.Player, "TOPLEFT", 0, 7)
			G.UnitFrames.Player.ArcaneChargeBar:Size(240, 3)
			local classBG = CreateFrame("Frame", classBG, G.UnitFrames.Player.ArcaneChargeBar)
			classBG:ClearAllPoints()
			classBG:SetPoint("TOPLEFT", -2, 2)
			classBG:SetPoint("BOTTOMRIGHT", 2, -2)
			classBG:Size(1, 1)
			classBG:SetTemplate("Default")
			classBG:CreateBorder(true, true)
			classBG:SetFrameStrata("Background")
			classBG:CreateShadow("Default")
			
		for i = 1, 6 do
			if i == 6 then
				G.UnitFrames.Player.ArcaneChargeBar[i]:Size(T.Scale(240 / 6), 3)
			else
					G.UnitFrames.Player.ArcaneChargeBar[i]:Size(T.Scale(240 / 6) - 1, 3)
			end
				
			if i == 1 then
				G.UnitFrames.Player.ArcaneChargeBar[i]:Point("LEFT", G.UnitFrames.Player.ArcaneChargeBar, "LEFT", 0, 0)
			else
				G.UnitFrames.Player.ArcaneChargeBar[i]:Point("LEFT", G.UnitFrames.Player.ArcaneChargeBar[i - 1], "RIGHT", 1, 0)
				end
			end
		end
	
			
		
		
		------------------------------
		-- rogue
		------------------------------
		if( T.myclass == "ROGUE" ) then
				G.UnitFrames.Player.ComboPointsBar:ClearAllPoints()
				G.UnitFrames.Player.ComboPointsBar:SetPoint( "BOTTOMLEFT", G.UnitFrames.Player, "TOPLEFT", 0, 7 )
				G.UnitFrames.Player.ComboPointsBar:Size( 240, 3 )
				
				--Border for the classbar.
				local classBG = CreateFrame("Frame", classBG, G.UnitFrames.Player.ComboPointsBar)
				classBG:ClearAllPoints()
				classBG:SetPoint("TOPLEFT", -2, 2)
				classBG:SetPoint("BOTTOMRIGHT", 2, -2)
				classBG:Size(1, 1)
				classBG:SetTemplate("Default")
				classBG:CreateBorder(true, true)
				classBG:SetFrameStrata("Background")
				classBG:CreateShadow("Default")

				for i = 1, 5 do
					if( i == 5 ) then
						G.UnitFrames.Player.ComboPointsBar[i]:Size( T.Scale( 240 / 5 ) - 4, 3 )
					else
						G.UnitFrames.Player.ComboPointsBar[i]:Size( T.Scale( 240 / 5 ), 3 )
					end

					if( i == 1 ) then
						G.UnitFrames.Player.ComboPointsBar[i]:SetPoint( "LEFT", G.UnitFrames.Player.ComboPointsBar, "LEFT", 0, 0 )
					else
						G.UnitFrames.Player.ComboPointsBar[i]:Point( "LEFT", G.UnitFrames.Player.ComboPointsBar[i - 1], "RIGHT", 1, 0 )
					end
				end
			end

		------------------------------
		-- deathknight
		------------------------------
		if( T.myclass == "DEATHKNIGHT" ) then
			G.UnitFrames.Player.Runes:ClearAllPoints()
			G.UnitFrames.Player.Runes:SetPoint( "BOTTOM", G.UnitFrames.Player, "TOP", 0, 7 )
			G.UnitFrames.Player.Runes:Size( 240, 3 )
			G.UnitFrames.Player.Runes:CreateBorder(false, true)
			
			--Border for the classbar.
				local classBG = CreateFrame("Frame", classBG, G.UnitFrames.Player.Runes)
				classBG:ClearAllPoints()
				classBG:SetPoint("TOPLEFT", -2, 2)
				classBG:SetPoint("BOTTOMRIGHT", 2, -2)
				classBG:Size(1, 1)
				classBG:SetTemplate("Default")
				classBG:CreateBorder(true, true)
				classBG:SetFrameStrata("Background")
				classBG:CreateShadow("Default")

			for i = 1, 6 do
				G.UnitFrames.Player.Runes[i]:Size( T.Scale( 237 / 6 ), 3 )
				if( i == 1 ) then
					G.UnitFrames.Player.Runes[i]:Size( T.Scale( 236 / 6 ) - 4, 3 )
					G.UnitFrames.Player.Runes[i]:ClearAllPoints()
					G.UnitFrames.Player.Runes[i]:SetPoint( "LEFT", G.UnitFrames.Player.Runes, "LEFT", 0, 0 )
				else
					G.UnitFrames.Player.Runes[i]:Size( T.Scale( 237 / 6 ), 3 )
					G.UnitFrames.Player.Runes[i]:Point( "LEFT", G.UnitFrames.Player.Runes[i - 1], "RIGHT", 1, 0 )
				end
			end
			
			-- Statue shizzle.
			G.UnitFrames.Player.Statue:ClearAllPoints()
			if C.unitframes.charportrait == true and integrateportrait == false then
				G.UnitFrames.Player.Statue:Point("RIGHT", G.UnitFrames.Player.Portrait, "LEFT", -7, 0)
			else
				G.UnitFrames.Player.Statue:Point("RIGHT", G.UnitFrames.Player.Health, "LEFT", -7, 0)
			end
			G.UnitFrames.Player.Statue:SetOrientation'VERTICAL'
			G.UnitFrames.Player.Statue:Size(3, G.UnitFrames.Player.Health:GetHeight())
			
			
			
			--Border for the StatueBar.
				local statueBG = CreateFrame("Frame", statueBG, G.UnitFrames.Player.Statue)
				statueBG:ClearAllPoints()
				statueBG:SetPoint("TOPLEFT", -2, 2)
				statueBG:SetPoint("BOTTOMRIGHT", 2, -2)
				statueBG:Size(1, 1)
				statueBG:SetTemplate("Default")
				statueBG:CreateBorder(true, true)
				statueBG:SetFrameStrata("Background")
				statueBG:CreateShadow("Default")
		end

		------------------------------
		-- monk
		------------------------------
		if( T.myclass == "MONK" ) then
			G.UnitFrames.Player.HarmonyBar:ClearAllPoints()
			G.UnitFrames.Player.HarmonyBar:SetPoint( "BOTTOM", G.UnitFrames.Player, "TOP", 0, 7 )
			G.UnitFrames.Player.HarmonyBar:Size( 240, 3 )
			G.UnitFrames.Player.HarmonyBar:SetBackdrop(nil)
			

			for i = 1, 5 do
				G.UnitFrames.Player.HarmonyBar[i]:Size( 47, 3 )
				G.UnitFrames.Player.HarmonyBar[i]:CreateBorder(false, true)
				if( i == 1 ) then
					G.UnitFrames.Player.HarmonyBar[i]:SetPoint( "BOTTOM", G.UnitFrames.Player, "TOP", 0, 7 )
				else
					G.UnitFrames.Player.HarmonyBar[i]:Point( "LEFT", G.UnitFrames.Player.HarmonyBar[i - 1], "RIGHT", 1, 0 )
				end
				
				--Border for the classbar.
				local classBG = CreateFrame("Frame", classBG, G.UnitFrames.Player.HarmonyBar)
				classBG:ClearAllPoints()
				classBG:SetPoint("TOPLEFT", -2, 2)
				classBG:SetPoint("BOTTOMRIGHT", 2, -2)
				classBG:Size(1, 1)
				classBG:SetTemplate("Default")
				classBG:CreateBorder(true, true)
				classBG:SetFrameStrata("Background")
				
				-- Statue shizzle.
				G.UnitFrames.Player.Statue:ClearAllPoints()
			if C.unitframes.charportrait == true and integrateportrait == false then
				G.UnitFrames.Player.Statue:Point("RIGHT", G.UnitFrames.Player.Portrait, "LEFT", -7, 0)
			else
				G.UnitFrames.Player.Statue:Point("RIGHT", G.UnitFrames.Player.Health, "LEFT", -7, 0)
			end
				G.UnitFrames.Player.Statue:SetOrientation'VERTICAL'
				G.UnitFrames.Player.Statue:Size(3, G.UnitFrames.Player.Health:GetHeight())
			
			
			
				--Border for the StatueBar.
				local statueBG = CreateFrame("Frame", statueBG, G.UnitFrames.Player.Statue)
				statueBG:ClearAllPoints()
				statueBG:SetPoint("TOPLEFT", -2, 2)
				statueBG:SetPoint("BOTTOMRIGHT", 2, -2)
				statueBG:Size(1, 1)
				statueBG:SetTemplate("Default")
				statueBG:CreateBorder(true, true)
				statueBG:SetFrameStrata("Background")
				statueBG:CreateShadow("Default")
			end
		end

		------------------------------
		-- shaman
		------------------------------
		if( T.myclass == "SHAMAN" ) then
		
		for i = 1, 4 do
				G.UnitFrames.Player.TotemBar[i]:ClearAllPoints()
				G.UnitFrames.Player.TotemBar[i]:Size(218 / 4, 3 )

				if( i == 1 ) then
					G.UnitFrames.Player.TotemBar[i]:SetPoint( "BOTTOMLEFT", G.UnitFrames.Player, "TOPLEFT", 0, 7 )
				else
					G.UnitFrames.Player.TotemBar[i]:Point( "LEFT", G.UnitFrames.Player.TotemBar[i - 1], "RIGHT", 7, 0 )
				end
				
				--Border for the classbar.
				local classBG = CreateFrame("Frame", classBG, G.UnitFrames.Player.TotemBar[i])
				classBG:ClearAllPoints()
				classBG:SetPoint("TOPLEFT", -2, 2)
				classBG:SetPoint("BOTTOMRIGHT", 2, -2)
				classBG:Size(1, 1)
				classBG:SetTemplate("Default")
				classBG:CreateBorder(true, true)
				classBG:SetFrameStrata("Background")
				classBG:CreateShadow("Default")

			end
		end
	end
	
	------------------------------
	-- Priest.
	------------------------------
	do
		if (T.myclass == "PRIEST") then
			G.UnitFrames.Player.ShadowOrbsBar:ClearAllPoints()
			G.UnitFrames.Player.ShadowOrbsBar:SetPoint("BOTTOMLEFT", G.UnitFrames.Player, "TOPLEFT", 0, 7)
			G.UnitFrames.Player.ShadowOrbsBar:Size(240, 3)
			G.UnitFrames.Player.ShadowOrbsBar:CreateBorder(false, true)

		for i = 1, 3 do
			G.UnitFrames.Player.ShadowOrbsBar[i]:Size(T.Scale(240 / 3), 3)
		
			if (i == 1) then
				G.UnitFrames.Player.ShadowOrbsBar[i]:SetPoint("LEFT", G.UnitFrames.Player.ShadowOrbsBar, "LEFT", 0, 0)
			else 
				G.UnitFrames.Player.ShadowOrbsBar[i]:SetPoint("LEFT", G.UnitFrames.Player.ShadowOrbsBar[i - 1], "RIGHT", 1, 0)
			end
		end
			
		--Border for the classbar.
			local classBG = CreateFrame("Frame", classBG, G.UnitFrames.Player.ShadowOrbsBar)
			classBG:ClearAllPoints()
			classBG:SetPoint("TOPLEFT", -2, 2)
			classBG:SetPoint("BOTTOMRIGHT", 2, -2)
			classBG:Size(1, 1)
			classBG:SetTemplate("Default")
			classBG:CreateBorder(true, true)
			classBG:SetFrameStrata("Background")
			classBG:CreateShadow("Default")
			
			-- Statue shizzle.
			G.UnitFrames.Player.Statue:ClearAllPoints()
			if C.unitframes.charportrait == true and integrateportrait == false then
				G.UnitFrames.Player.Statue:Point("RIGHT", G.UnitFrames.Player.Portrait, "LEFT", -7, 0)
			else
				G.UnitFrames.Player.Statue:Point("RIGHT", G.UnitFrames.Player.Health, "LEFT", -7, 0)
			end
			G.UnitFrames.Player.Statue:SetOrientation'VERTICAL'
			G.UnitFrames.Player.Statue:Size(3, G.UnitFrames.Player.Health:GetHeight())
			
			
			
		--Border for the StatueBar.
			local statueBG = CreateFrame("Frame", statueBG, G.UnitFrames.Player.Statue)
			statueBG:ClearAllPoints()
			statueBG:SetPoint("TOPLEFT", -2, 2)		
			statueBG:SetPoint("BOTTOMRIGHT", 2, -2)
			statueBG:Size(1, 1)
			statueBG:SetTemplate("Default")
			statueBG:CreateBorder(true, true)
			statueBG:SetFrameStrata("Background")
			statueBG:CreateShadow("Default")
		end
	end
	
	------------------------------
	--	Warrior.
	------------------------------
	do
		if (T.myclass == "WARRIOR") then
			-- Statue shizzle.
				G.UnitFrames.Player.Statue:ClearAllPoints()
			if C.unitframes.charportrait == true and integrateportrait == false then
				G.UnitFrames.Player.Statue:Point("RIGHT", G.UnitFrames.Player.Portrait, "LEFT", -7, 0)
			else
				G.UnitFrames.Player.Statue:Point("RIGHT", G.UnitFrames.Player.Health, "LEFT", -7, 0)
			end
				G.UnitFrames.Player.Statue:SetOrientation'VERTICAL'
				G.UnitFrames.Player.Statue:Size(3, G.UnitFrames.Player.Health:GetHeight())
			
			
			
				--Border for the StatueBar.
				local statueBG = CreateFrame("Frame", statueBG, G.UnitFrames.Player.Statue)
				statueBG:ClearAllPoints()
				statueBG:SetPoint("TOPLEFT", -2, 2)
				statueBG:SetPoint("BOTTOMRIGHT", 2, -2)
				statueBG:Size(1, 1)
				statueBG:SetTemplate("Default")
				statueBG:CreateBorder(true, true)
				statueBG:SetFrameStrata("Background")
				statueBG:CreateShadow("Default")
		end
	end
	
	------------------------------
	-- castbar
	------------------------------
	do
		if( C["unitframes"]["unitcastbar"] == true ) then
			G.UnitFrames.Player.Castbar:ClearAllPoints()
			G.UnitFrames.Player.Castbar:SetHeight(19)
			G.UnitFrames.Player.Castbar:Point( "BOTTOMRIGHT", TukuiBar1, "TOPRIGHT", -2, 5 )
			G.UnitFrames.Player.Castbar:CreateBorder(false, true)
			G.UnitFrames.Player.Castbar.bg:SetVertexColor( 0.05, 0.05, 0.05, 1)
			
			--Border for the castbar.
				local castBG = CreateFrame("Frame", castBG, G.UnitFrames.Player.Castbar)
				castBG:ClearAllPoints()
				castBG:SetPoint("TOPLEFT", -2, 2)
				castBG:SetPoint("BOTTOMRIGHT", 2, -2)
				castBG:Size(1, 1)
				castBG:SetTemplate("Default")
				castBG:CreateBorder(true, true)
				castBG:SetFrameStrata("Background")
				castBG:CreateShadow("Default")

			if( C["unitframes"]["cbicons"] == true ) then
				G.UnitFrames.Player.Castbar:Width( T.Scale(TukuiBar1:GetWidth() - 4) - 26 )

				G.UnitFrames.Player.Castbar.button:ClearAllPoints()
				G.UnitFrames.Player.Castbar.button:SetPoint( "RIGHT", G.UnitFrames.Player.Castbar, "LEFT", -5, 0 )
				G.UnitFrames.Player.Castbar.button:Size( 23 )
				G.UnitFrames.Player.Castbar.button:CreateShadow("Default")
			else
				G.UnitFrames.Player.Castbar:Width( TukuiBar1:GetWidth() - 4 )
			end

			G.UnitFrames.Player.Castbar.PostCastStart = T.PostCastStart
			G.UnitFrames.Player.Castbar.PostChannelStart = T.PostCastStart

			G.UnitFrames.Player.Castbar.Time = T.SetFontString( G.UnitFrames.Player.Castbar, T.CreateFontString())
			G.UnitFrames.Player.Castbar.Time:Point( "RIGHT", G.UnitFrames.Player.Castbar, "RIGHT", -4, 1 )
			G.UnitFrames.Player.Castbar.Time:SetTextColor( 1, 1, 1 )
			G.UnitFrames.Player.Castbar.Time:SetShadowOffset(0, 0)

			G.UnitFrames.Player.Castbar.Text = T.SetFontString( G.UnitFrames.Player.Castbar, T.CreateFontString())
			G.UnitFrames.Player.Castbar.Text:Point( "LEFT", G.UnitFrames.Player.Castbar, "LEFT", 4, 1 )
			G.UnitFrames.Player.Castbar.Text:SetTextColor( 1, 1, 1 )
			G.UnitFrames.Player.Castbar.Text:SetShadowOffset(0, 0)

			if( C["unitframes"]["cblatency"] == true ) then
				G.UnitFrames.Player.Castbar.SafeZone:SetVertexColor( 1, 1, 1 )
			end
		end
	end

	------------------------------
	-- fader
	------------------------------
	do
		if( C["unitframes"]["fader"] == true ) then
			G.UnitFrames.Player.FadeCasting = true
			G.UnitFrames.Player.FadeCombat = true
			G.UnitFrames.Player.FadeTarget = true
			G.UnitFrames.Player.FadeHealth = true
			G.UnitFrames.Player.FadePower = true
			G.UnitFrames.Player.FadeHover = true

			G.UnitFrames.Player.FadeSmooth = 0.5
			G.UnitFrames.Player.FadeMinAlpha = 0.3
			G.UnitFrames.Player.FadeMaxAlpha = 1

			G.UnitFrames.Player:EnableElement( "Fader" )
		end
	end

	------------------------------
	-- size
	------------------------------
	do
		G.UnitFrames.Player:Size( 240, 27 )
	end


end

------------------------------
-- Target
------------------------------
do
	------------------------------
	-- not needed
	------------------------------
	do
		G.UnitFrames.Target:SetBackdrop( nil )
		G.UnitFrames.Target:SetBackdropColor( 0, 0, 0 )
		G.UnitFrames.Target.shadow:Kill()
		G.UnitFrames.Target.panel:Kill()
	end

	------------------------------
	-- health
	------------------------------
	do
		G.UnitFrames.Target.Health:Height( 27 )
		G.UnitFrames.Target.Health:SetFrameLevel( 9 )
		G.UnitFrames.Target.Health:SetFrameStrata("LOW")
		G.UnitFrames.Target.Health:CreateBorder(false, true)
		G.UnitFrames.Target.Health.bg:SetTexture(.6, .5, .5)
		
		--Border for the health bar.
				local healthBG = CreateFrame("Frame", healthBG, G.UnitFrames.Target.Health)
				healthBG:ClearAllPoints()
				healthBG:SetPoint("TOPLEFT", -2, 2)
				healthBG:SetPoint("BOTTOMRIGHT", 2, -2)
				healthBG:Size(1, 1)
				healthBG:SetTemplate("Default")
				healthBG:CreateBorder(true, true)
				healthBG:SetFrameStrata("Low")
				healthBG:SetFrameLevel(G.UnitFrames.Player.Health:GetFrameLevel())
				healthBG:CreateShadow("Default")

		if( C["unitframes"]["unicolor"] == true ) then
			G.UnitFrames.Target.Health.colorTapping = false
			G.UnitFrames.Target.Health.colorDisconnected = false
			G.UnitFrames.Target.Health.colorClass = false
			G.UnitFrames.Target.Health:SetStatusBarColor( 0.12, 0.12, 0.12)
			G.UnitFrames.Target.Health.bg:SetVertexColor( .6, .3, .3, 1 )
		else
			G.UnitFrames.Target.Health.bg:SetVertexColor(.05, .05, .05)
			G.UnitFrames.Target.Health.colorDisconnected = true
			G.UnitFrames.Target.Health.colorTapping = true
			G.UnitFrames.Target.Health.colorClass = true
			G.UnitFrames.Target.Health.colorReaction = true
		end
		
		G.UnitFrames.Target.Name:SetFont(T.CreateFontString())
		G.UnitFrames.Target.Name:ClearAllPoints()
		G.UnitFrames.Target.Name:SetPoint("CENTER", G.UnitFrames.Target.Health, "CENTER", 0, 0)
		G.UnitFrames.Target.Name:SetShadowOffset(0, 0)

		G.UnitFrames.Target.Health.value = T.SetFontString( G.UnitFrames.Target.Health, T.CreateFontString())
		G.UnitFrames.Target.Health.value:Point( "RIGHT", G.UnitFrames.Target.Health, "RIGHT", -4, 1 )
		G.UnitFrames.Target.Health.value:SetShadowOffset(0, 0)

		G.UnitFrames.Target.Health.PostUpdate = T.PostUpdateHealth
		

	end

	------------------------------
	-- power
	------------------------------
	do
		G.UnitFrames.Target.Power:Size( 240, 27 )
		G.UnitFrames.Target.Power:ClearAllPoints()
		G.UnitFrames.Target.Power:SetFrameLevel(1)
		G.UnitFrames.Target.Power:SetFrameStrata("Background")
		G.UnitFrames.Target.Power:Point( "BOTTOMRIGHT", G.UnitFrames.Target.Health, "BOTTOMRIGHT", -6, -6 )
		G.UnitFrames.Target.Power:CreateBorder(false, true)
		
		--Border for the powerbar.
				local powerBG = CreateFrame("Frame", powerBG, G.UnitFrames.Target.Power)
				powerBG:ClearAllPoints()
				powerBG:SetPoint("TOPLEFT", -2, 2)
				powerBG:SetPoint("BOTTOMRIGHT", 2, -2)
				powerBG:Size(1, 1)
				powerBG:SetTemplate("Default")
				powerBG:CreateBorder(true, true)
				powerBG:SetFrameStrata("Background")
				powerBG:SetFrameLevel(G.UnitFrames.Player.Power:GetFrameLevel())
				powerBG:CreateShadow("Default")

		G.UnitFrames.Target.Power.value = T.SetFontString( G.UnitFrames.Target.Health, T.CreateFontString())
		G.UnitFrames.Target.Power.value:Point( "LEFT", G.UnitFrames.Target.Health, "LEFT", 4, 1 )
		G.UnitFrames.Target.Power.value:SetShadowOffset(0, 0)

		if( C["unitframes"]["unicolor"] == true ) then
			G.UnitFrames.Target.Power.colorTapping = true
			G.UnitFrames.Target.Power.colorClass = true
			G.UnitFrames.Target.Power.bg.multiplier = 0.1
		else
			G.UnitFrames.Target.Power.colorPower = true
		end
	end

	
	
	
	------------------------------
	-- portraits
	------------------------------
	do
		if( C["unitframes"]["charportrait"] == true ) then
		
		if C.unitframes.integrateportrait == true then
			G.UnitFrames.Target.Portrait:ClearAllPoints()
			G.UnitFrames.Target.Portrait:SetPoint("TOPLEFT", G.UnitFrames.Target.Health, 0, -1)
			G.UnitFrames.Target.Portrait:SetPoint("BOTTOMRIGHT", G.UnitFrames.Target.Health, 0, 1)
			G.UnitFrames.Target.Portrait:SetAlpha( 0.2 )
			G.UnitFrames.Target.Portrait.SetAlpha = T.dummy
			G.UnitFrames.Target.Health:ClearAllPoints()
			G.UnitFrames.Target.Health:SetPoint( "TOPLEFT", 0, 0 )
			G.UnitFrames.Target.Health:SetPoint( "TOPRIGHT" )
			G.UnitFrames.Target.Portrait:SetFrameLevel( G.UnitFrames.Target.Health:GetFrameLevel() )
		else
			G.UnitFrames.Target.Portrait:ClearAllPoints()
			G.UnitFrames.Target.Portrait:SetPoint("LEFT", G.UnitFrames.Target.Health, "RIGHT", 7, -3)
			G.UnitFrames.Target.Portrait:Size(60, G.UnitFrames.Target.Health:GetHeight() + 5)
			G.UnitFrames.Target.Portrait:SetFrameLevel( G.UnitFrames.Target.Health:GetFrameLevel() )
			G.UnitFrames.Target.Health:ClearAllPoints()
			G.UnitFrames.Target.Health:SetPoint( "TOPLEFT", 0, 0 )
			G.UnitFrames.Target.Health:SetPoint( "TOPRIGHT" )
			
			--Border for the portrait.
				local portraitBG = CreateFrame("Frame", portraitBG, G.UnitFrames.Target.Portrait)
				portraitBG:ClearAllPoints()
				portraitBG:SetPoint("TOPLEFT", -2, 2)
				portraitBG:SetPoint("BOTTOMRIGHT", 2, -3)
				portraitBG:Size(1, 1)
				portraitBG:SetTemplate("Transparent")
				portraitBG:CreateBorder(true, true)
				portraitBG:HideInsets()
				portraitBG:CreateShadow("Default")
				portraitBG:SetFrameStrata("Background")
				portraitBG:SetFrameLevel(G.UnitFrames.Target.Portrait:GetFrameLevel())
			end
		end
	end

	------------------------------
	-- combat feedback
	------------------------------
	do
		if( C["unitframes"]["combatfeedback"] == true ) then
			G.UnitFrames.Target.CombatFeedbackText:SetFont(T.CreateFontString() )
			G.UnitFrames.Target.CombatFeedbackText:SetShadowOffset(0, 0)
		end
	end

	------------------------------
	-- castbar
	------------------------------
	do

		if( C["unitframes"]["unitcastbar"] == true ) then
			G.UnitFrames.Target.Castbar:ClearAllPoints()
			G.UnitFrames.Target.Castbar:SetHeight( 19 )
			G.UnitFrames.Target.Castbar:Point( "BOTTOM", UIParent, "BOTTOM", 0, 220 )
			G.UnitFrames.Target.Castbar:CreateBorder(false, true)
			G.UnitFrames.Target.Castbar.bg:SetVertexColor( 0.05, 0.05, 0.05, 1)
			
			--Border for the castbar.
				local castBG = CreateFrame("Frame", castBG, G.UnitFrames.Target.Castbar)
				castBG:ClearAllPoints()
				castBG:SetPoint("TOPLEFT", -2, 2)
				castBG:SetPoint("BOTTOMRIGHT", 2, -2)
				castBG:Size(1, 1)
				castBG:SetTemplate("Default")
				castBG:CreateBorder(true, true)
				castBG:SetFrameStrata("Background")
				castBG:CreateShadow("Default")

			if( C["unitframes"]["cbicons"] == true ) then
				G.UnitFrames.Target.Castbar:Width( 250 - 40 )

				G.UnitFrames.Target.Castbar.button:ClearAllPoints()
				G.UnitFrames.Target.Castbar.button:SetPoint( "LEFT", G.UnitFrames.Target.Castbar, "RIGHT", 5, 0 )
				G.UnitFrames.Target.Castbar.button:Size( 23 )
				G.UnitFrames.Target.Castbar.button:CreateShadow("Default")
			else
				G.UnitFrames.Target.Castbar:Width( 250 )
			end

			G.UnitFrames.Target.Castbar.PostCastStart = T.PostCastStart
			G.UnitFrames.Target.Castbar.PostChannelStart = T.PostCastStart

			G.UnitFrames.Target.Castbar.Time = T.SetFontString( G.UnitFrames.Target.Castbar, T.CreateFontString())
			G.UnitFrames.Target.Castbar.Time:Point( "RIGHT", G.UnitFrames.Target.Castbar, "RIGHT", -4, 1 )
			G.UnitFrames.Target.Castbar.Time:SetTextColor( 1, 1, 1 )
			G.UnitFrames.Target.Castbar.Time:SetShadowOffset(0, 0)

			G.UnitFrames.Target.Castbar.Text = T.SetFontString( G.UnitFrames.Target.Castbar, T.CreateFontString())
			G.UnitFrames.Target.Castbar.Text:Point( "LEFT", G.UnitFrames.Target.Castbar, "LEFT", 4, 1 )
			G.UnitFrames.Target.Castbar.Text:SetTextColor( 1, 1, 1 )
			G.UnitFrames.Target.Castbar.Text:SetShadowOffset(0, 0)
		end
	end

	------------------------------
	-- buffs, debuffs
	------------------------------
	--Skin target auras.
local player = G.UnitFrames.Player
local target = G.UnitFrames.Target
-- etc

-- our update (hook) or the original buff/debuffs button creation)
local function PostCreateAura(self, button)
	-- kill the glow
	button.Glow:Kill()

	-- move icon just 1px inside the black inset (it hide 1px borders)
	button:CreateBorder(true, true)
	button:CreateShadow("Default")
	button.icon:Point("TOPLEFT", 2, -2)
	button.icon:Point("BOTTOMRIGHT", -2, 2)

	-- resize the cooldown tex to fix new icon size
	button.cd:Point("TOPLEFT", button, "TOPLEFT", 0, 0)
	button.cd:Point("BOTTOMRIGHT", button, "BOTTOMRIGHT", 0, 0)

	-- change the font
	button.remaining:SetFont(T.CreateFontString())
end
hooksecurefunc(T, "PostCreateAura", PostCreateAura)

if target then
	local buffs = target.Buffs
	local debuffs = target.Debuffs

	
	-- edited position, size, space, etc of buffs
	buffs:SetHeight(24.5)
	buffs:SetWidth(240)
	buffs.size = 24.5
	buffs.num = 9
	buffs.spacing = 3
	buffs.initialAnchor = 'TOPLEFT'
	buffs["growth-y"] = "UP"
	buffs["growth-x"] = "RIGHT"
	buffs:SetPoint("BOTTOMLEFT", target, "TOPLEFT", -2, 5)
	buffs.PostCreateIcon = T.PostCreateAura
	buffs.PostUpdateIcon = T.PostUpdateAura
	
	-- edited position, size, space, etc of buffs
	debuffs:SetHeight(24.5)
	debuffs:SetWidth(240)
	debuffs.size = 24.5
	debuffs.num = 21
	debuffs.spacing = 3
	debuffs.initialAnchor = 'TOPRIGHT'
	debuffs["growth-y"] = "UP"
	debuffs["growth-x"] = "LEFT"
	debuffs:ClearAllPoints()
	debuffs:SetPoint("BOTTOMRIGHT", buffs, "TOPRIGHT", 5, 0)
	debuffs.PostCreateIcon = T.PostCreateAura
	debuffs.PostUpdateIcon = T.PostUpdateAura

	-- because default tukui update regularly the position of buffs/debuffs on this unit
	-- we need to disable the position update process
	buffs.ClearAllPoints = T.dummy
	buffs.SetPoint = T.dummy
end

	------------------------------
	-- fader
	------------------------------
	do
		if( C["unitframes"]["fader"] == true ) then
			G.UnitFrames.Target.FadeCasting = true
			G.UnitFrames.Target.FadeCombat = true
			G.UnitFrames.Target.FadeTarget = true
			G.UnitFrames.Target.FadeHealth = true
			G.UnitFrames.Target.FadePower = true
			G.UnitFrames.Target.FadeHover = true

			G.UnitFrames.Target.FadeSmooth = 0.5
			G.UnitFrames.Target.FadeMinAlpha = 0.3
			G.UnitFrames.Target.FadeMaxAlpha = 1

			G.UnitFrames.Target:EnableElement( "Fader" )
		end
	end

	------------------------------
	-- size
	------------------------------
	do
		G.UnitFrames.Target:Size( 240, 27 )
	end
end

------------------------------
-- Target of Target
------------------------------
do
	------------------------------
	-- not needed
	------------------------------
	do
		G.UnitFrames.TargetTarget:SetBackdrop( nil )
		G.UnitFrames.TargetTarget:SetBackdropColor( 0, 0, 0 )
		G.UnitFrames.TargetTarget.shadow:Kill()
		if not T.lowversion then
		G.UnitFrames.TargetTarget.panel:Kill()
		end
	end

	------------------------------
	-- health
	------------------------------
	do
		G.UnitFrames.TargetTarget.Health:Size( 110, 27 )
		G.UnitFrames.TargetTarget.Health:SetFrameLevel( 5 )
		G.UnitFrames.TargetTarget.Health:CreateBorder(false, true)
		G.UnitFrames.TargetTarget.Health.bg:SetTexture(.6, .5, .5)
		
		--Border for the health bar.
				local healthBG = CreateFrame("Frame", healthBG, G.UnitFrames.TargetTarget.Health)
				healthBG:ClearAllPoints()
				healthBG:SetPoint("TOPLEFT", -2, 2)
				healthBG:SetPoint("BOTTOMRIGHT", 2, -2)
				healthBG:Size(1, 1)
				healthBG:SetTemplate("Default")
				healthBG:CreateBorder(true, true)
				healthBG:SetFrameStrata("Low")
				healthBG:SetFrameLevel(G.UnitFrames.TargetTarget.Health:GetFrameLevel())
				healthBG:CreateShadow("Default")

		if( C["unitframes"]["unicolor"] == true ) then
			G.UnitFrames.TargetTarget.Health.colorTapping = false
			G.UnitFrames.TargetTarget.Health.colorDisconnected = false
			G.UnitFrames.TargetTarget.Health.colorClass = false
			G.UnitFrames.TargetTarget.Health:SetStatusBarColor( 0.12, 0.12, 0.12)
			G.UnitFrames.TargetTarget.Health.bg:SetVertexColor( 0.6, 0.3, 0.3, 1 )
		else
			G.UnitFrames.TargetTarget.Health.bg:SetVertexColor(.05, .05, .05)
			G.UnitFrames.TargetTarget.Health.colorDisconnected = true
			G.UnitFrames.TargetTarget.Health.colorTapping = true
			G.UnitFrames.TargetTarget.Health.colorClass = true
			G.UnitFrames.TargetTarget.Health.colorReaction = true
		end

		G.UnitFrames.TargetTarget.Name:SetFont(T.CreateFontString() )
		G.UnitFrames.TargetTarget.Name:SetShadowOffset(0, 0)
		
	end

	------------------------------
	-- power
	------------------------------
	do
		local TargetTargetPower = CreateFrame( "StatusBar", nil, G.UnitFrames.TargetTarget )
		TargetTargetPower:Size( 122, 27 )
		TargetTargetPower:SetFrameStrata("LOW")
		TargetTargetPower:Point( "TOP", G.UnitFrames.TargetTarget.Health, "TOP", 0, -6 )
		TargetTargetPower:CreateBorder(false, true)
		TargetTargetPower:SetStatusBarTexture(C.media.normTex)
		
		--Border for the powerbar.
				local powerBG = CreateFrame("Frame", powerBG, TargetTargetPower)
				powerBG:ClearAllPoints()
				powerBG:SetPoint("TOPLEFT", -2, 2)
				powerBG:SetPoint("BOTTOMRIGHT", 2, -2)
				powerBG:Size(1, 1)
				powerBG:SetTemplate("Default")
				powerBG:CreateBorder(true, true)
				powerBG:SetFrameStrata("Background")
				powerBG:SetFrameLevel(G.UnitFrames.Player.Power:GetFrameLevel())
				powerBG:CreateShadow("Default")

		local TargetTargetPowerBackground = TargetTargetPower:CreateTexture( nil, "BORDER" )
		TargetTargetPowerBackground:SetAllPoints( TargetTargetPower )
		TargetTargetPowerBackground:SetTexture( C["media"]["normTex"] )
		TargetTargetPowerBackground.multiplier = 0.1

		TargetTargetPower.frequentUpdates = true
		TargetTargetPower.colorDisconnected = true

		if( C["unitframes"]["showsmooth"] == true ) then
			TargetTargetPower.Smooth = true
		end

		if( C["unitframes"]["unicolor"] == true ) then
			TargetTargetPower.colorTapping = true
			TargetTargetPower.colorClass = true
			TargetTargetPower.colorReaction = true
			TargetTargetPowerBackground.multiplier = 0.1
		else
			TargetTargetPower.colorPower = true
		end

		G.UnitFrames.TargetTarget.Power = TargetTargetPower
		G.UnitFrames.TargetTarget.Power.bg = TargetTargetPowerBackground

		G.UnitFrames.TargetTarget:EnableElement( "Power" )
	end

	------------------------------
	-- buffs, debuffs
	------------------------------
	do
		if( C["unitframes"]["totdebuffs"] == true ) then
			G.UnitFrames.TargetTarget.Debuffs:SetHeight(19)
			G.UnitFrames.TargetTarget.Debuffs:SetWidth(120)
			G.UnitFrames.TargetTarget.Debuffs.size = 19
			G.UnitFrames.TargetTarget.Debuffs.num = 6
			G.UnitFrames.TargetTarget.Debuffs.spacing = 3

			G.UnitFrames.TargetTarget.Debuffs:ClearAllPoints()
			G.UnitFrames.TargetTarget.Debuffs:Point("TOP", G.UnitFrames.TargetTarget.Power, "BOTTOM", -3, -5)
			G.UnitFrames.TargetTarget.Debuffs.ClearAllPoints = T.dummy
			G.UnitFrames.TargetTarget.Debuffs.SetPoint = T.dummy

			G.UnitFrames.TargetTarget.Debuffs.initialAnchor = "LEFT"
			G.UnitFrames.TargetTarget.Debuffs["growth-x"] = "RIGHT"

			if( G.UnitFrames.TargetTarget.Debuffs ) then
				for _, frames in pairs({G.UnitFrames.TargetTarget.Debuffs}) do
					if( not frames ) then return end

					frames:Size(120, 19)
					frames.size = 19
					frames.num = 6

				end
			end
		end
	end

	------------------------------
	-- size
	------------------------------
	do
		G.UnitFrames.TargetTarget:Size( 110, 19 )
	end
end

------------------------------
-- Pet
------------------------------
do
	------------------------------
	-- not needed
	------------------------------
	do
		G.UnitFrames.Pet:SetBackdrop( nil )
		G.UnitFrames.Pet:SetBackdropColor( 0, 0, 0 )
		G.UnitFrames.Pet.shadow:Kill()
		if not T.lowversion then
		G.UnitFrames.Pet.panel:Kill()
		end
	end

	------------------------------
	-- health
	------------------------------
	do
		G.UnitFrames.Pet.Health:Size( 110, 27 )
		G.UnitFrames.Pet.Health:SetFrameLevel( 5 )
		G.UnitFrames.Pet.Health:CreateBorder(false, true)
		G.UnitFrames.Pet.Health.bg:SetTexture(.6, .5, .5)
		
		--Border for the health bar.
				local healthBG = CreateFrame("Frame", healthBG, G.UnitFrames.Pet.Health)
				healthBG:ClearAllPoints()
				healthBG:SetPoint("TOPLEFT", -2, 2)
				healthBG:SetPoint("BOTTOMRIGHT", 2, -2)
				healthBG:Size(1, 1)
				healthBG:SetTemplate("Default")
				healthBG:CreateBorder(true, true)
				healthBG:SetFrameStrata("Low")
				healthBG:SetFrameLevel(G.UnitFrames.TargetTarget.Health:GetFrameLevel())
				healthBG:CreateShadow("Default")

		if( C["unitframes"]["unicolor"] == true ) then
			G.UnitFrames.Pet.Health.colorTapping = false
			G.UnitFrames.Pet.Health.colorDisconnected = false
			G.UnitFrames.Pet.Health.colorClass = false
			G.UnitFrames.Pet.Health:SetStatusBarColor( 0.12, 0.12, 0.12)
			G.UnitFrames.Pet.Health.bg:SetVertexColor( .6, .3, .3, 1 )
		else
			G.UnitFrames.Pet.Health.bg:SetVertexColor(.05, .05, .05)
			G.UnitFrames.Pet.Health.colorDisconnected = true
			G.UnitFrames.Pet.Health.colorTapping = true
			G.UnitFrames.Pet.Health.colorClass = true
			G.UnitFrames.Pet.Health.colorReaction = true
		end

		G.UnitFrames.Pet.Name:SetFont(T.CreateFontString() )
		G.UnitFrames.Pet.Name:SetShadowOffset(0, 0)
		

	end

	------------------------------
	-- power
	------------------------------
	do
		G.UnitFrames.Pet.Power:Size( 122, 27)
		G.UnitFrames.Pet.Power:ClearAllPoints()
		G.UnitFrames.Pet.Power:SetPoint( "TOP", G.UnitFrames.Pet.Health, "TOP", 0, -6 )
		G.UnitFrames.Pet.Power:SetFrameStrata("LOW")
		G.UnitFrames.Pet.Power:CreateBorder(false, true)
		
		--Border for the powerbar.
				local powerBG = CreateFrame("Frame", powerBG, G.UnitFrames.Pet.Power)
				powerBG:ClearAllPoints()
				powerBG:SetPoint("TOPLEFT", -2, 2)
				powerBG:SetPoint("BOTTOMRIGHT", 2, -2)
				powerBG:Size(1, 1)
				powerBG:SetTemplate("Default")
				powerBG:CreateBorder(true, true)
				powerBG:SetFrameStrata("Background")
				powerBG:SetFrameLevel(G.UnitFrames.Player.Power:GetFrameLevel())
				powerBG:CreateShadow("Default")

	end

	
	------------------------------
	-- Castbar.
	------------------------------
	
	G.UnitFrames.Pet.Castbar:Kill() -- Why would I want this useless thing? =(
	------------------------------
	-- size
	------------------------------
	do
		G.UnitFrames.Pet:Size( 110, 19 )
	end
end

------------------------------
-- Pet Target
------------------------------
do

end

------------------------------
-- Focus
------------------------------
do
	------------------------------
	-- not needed
	------------------------------
	do
		G.UnitFrames.Focus:SetBackdrop( nil )
		G.UnitFrames.Focus:SetBackdropColor( 0, 0, 0 )
		G.UnitFrames.Focus.shadow:Kill()
	end

	------------------------------
	-- health
	------------------------------
	do
		G.UnitFrames.Focus.Health:Size( 215, 27 )
		G.UnitFrames.Focus.Health:SetFrameLevel( 5 )
		G.UnitFrames.Focus.Health:CreateBorder(false, true)
		G.UnitFrames.Focus.Health.bg:SetTexture(.6, .5, .5)
		
		--Border for the health bar.
				local healthBG = CreateFrame("Frame", healthBG, G.UnitFrames.Focus.Health)
				healthBG:ClearAllPoints()
				healthBG:SetPoint("TOPLEFT", -2, 2)
				healthBG:SetPoint("BOTTOMRIGHT", 2, -2)
				healthBG:Size(1, 1)
				healthBG:SetTemplate("Default")
				healthBG:CreateBorder(true, true)
				healthBG:SetFrameStrata("Low")
				healthBG:SetFrameLevel(G.UnitFrames.TargetTarget.Health:GetFrameLevel())
				healthBG:CreateShadow("Default")

		if( C["unitframes"]["unicolor"] == true ) then
			G.UnitFrames.Focus.Health.colorTapping = false
			G.UnitFrames.Focus.Health.colorDisconnected = false
			G.UnitFrames.Focus.Health.colorClass = false
			G.UnitFrames.Focus.Health:SetStatusBarColor( 0.12, 0.12, 0.12, 1 )
			G.UnitFrames.Focus.Health.bg:SetVertexColor( 0.6, 0.3, 0.3, 1 )
		else
			G.UnitFrames.Focus.Health.bg:SetVertexColor( .05, .05, .05, 1 )
			G.UnitFrames.Focus.Health.colorDisconnected = true
			G.UnitFrames.Focus.Health.colorTapping = true
			G.UnitFrames.Focus.Health.colorClass = true
			G.UnitFrames.Focus.Health.colorReaction = true
		end

		G.UnitFrames.Focus.Name:SetFont(T.CreateFontString() )
		G.UnitFrames.Focus.Name:Point( "CENTER", G.UnitFrames.Focus.Health, "CENTER", 0, 1 )
		G.UnitFrames.Focus.Name:SetShadowOffset(0, 0)
		
		G.UnitFrames.Focus.Health.value = T.SetFontString( G.UnitFrames.Focus.Health, T.CreateFontString())
		G.UnitFrames.Focus.Health.value:Point( "RIGHT", G.UnitFrames.Focus.Health, "RIGHT", -4, 1 )
		G.UnitFrames.Focus.Health.value:SetShadowOffset(0, 0)
		

	end

	------------------------------
	-- power
	------------------------------
	do
		G.UnitFrames.Focus.Power:Size( 215, 27 )
		G.UnitFrames.Focus.Power:ClearAllPoints()
		G.UnitFrames.Focus.Power:Point( "BOTTOMRIGHT", G.UnitFrames.Focus.Health, "BOTTOMRIGHT", 6, -6 )
		G.UnitFrames.Focus.Power:CreateBorder(false, true)
		G.UnitFrames.Focus.Power:SetFrameStrata("Low")
		
		--Border for the powerbar.
				local powerBG = CreateFrame("Frame", powerBG, G.UnitFrames.Focus.Power)
				powerBG:ClearAllPoints()
				powerBG:SetPoint("TOPLEFT", -2, 2)
				powerBG:SetPoint("BOTTOMRIGHT", 2, -2)
				powerBG:Size(1, 1)
				powerBG:SetTemplate("Default")
				powerBG:CreateBorder(true, true)
				powerBG:SetFrameStrata("Background")
				powerBG:SetFrameLevel(G.UnitFrames.Player.Power:GetFrameLevel())
				powerBG:CreateShadow("Default")

		G.UnitFrames.Focus.Power.value = T.SetFontString( G.UnitFrames.Focus.Health, T.CreateFontString())
		G.UnitFrames.Focus.Power.value:Point( "LEFT", G.UnitFrames.Focus.Health, "LEFT", 4, 1 )
		G.UnitFrames.Focus.Power.value:SetShadowOffset(0, 0)
	end
	
	

	------------------------------
	-- castbar
	------------------------------
	do
		if( C["unitframes"]["unitcastbar"] == true ) then
			G.UnitFrames.Focus.Castbar:ClearAllPoints()
			G.UnitFrames.Focus.Castbar:SetHeight( 19 )
			G.UnitFrames.Focus.Castbar:Point( "TOPLEFT", G.UnitFrames.Focus.Power, "BOTTOMLEFT", 0, -7 )
			G.UnitFrames.Focus.Castbar:CreateBorder(false, true)
			
			--Border for the castbar.
				local castBG = CreateFrame("Frame", castBG, G.UnitFrames.Focus.Castbar)
				castBG:ClearAllPoints()
				castBG:SetPoint("TOPLEFT", -2, 2)
				castBG:SetPoint("BOTTOMRIGHT", 2, -2)
				castBG:Size(1, 1)
				castBG:SetTemplate("Default")
				castBG:CreateBorder(true, true)
				castBG:SetFrameStrata("Background")
				castBG:CreateShadow("Default")

			G.UnitFrames.Focus.Castbar.bg:Kill()

			G.UnitFrames.Focus.Castbar.bg = G.UnitFrames.Focus.Castbar:CreateTexture( nil, "BORDER" )
			G.UnitFrames.Focus.Castbar.bg:SetAllPoints( G.UnitFrames.Focus.Castbar )
			G.UnitFrames.Focus.Castbar.bg:SetTexture( C["media"]["normTex"] )
			G.UnitFrames.Focus.Castbar.bg:SetVertexColor( .05, .05, .05, .5 )

			G.UnitFrames.Focus.Castbar.Time = T.SetFontString( G.UnitFrames.Focus.Castbar, T.CreateFontString() )
			G.UnitFrames.Focus.Castbar.Time:Point( "RIGHT", G.UnitFrames.Focus.Castbar, "RIGHT", -4, 1 )
			G.UnitFrames.Focus.Castbar.Time:SetTextColor( 1, 1, 1 )
			G.UnitFrames.Focus.Castbar.Time:SetShadowOffset(0, 0)

			G.UnitFrames.Focus.Castbar.Text = T.SetFontString( G.UnitFrames.Focus.Castbar, T.CreateFontString() )
			G.UnitFrames.Focus.Castbar.Text:Point( "LEFT", G.UnitFrames.Focus.Castbar, "LEFT", 4, 1 )
			G.UnitFrames.Focus.Castbar.Text:SetTextColor( 1, 1, 1 )
			G.UnitFrames.Focus.Castbar.Text:SetShadowOffset(0, 0)

			G.UnitFrames.Focus.Castbar.PostCastStart = T.PostCastStart
			G.UnitFrames.Focus.Castbar.PostChannelStart = T.PostCastStart

			if( C["unitframes"]["cbicons"] == true ) then
				G.UnitFrames.Focus.Castbar:Width( 215 - 26 )

				G.UnitFrames.Focus.Castbar.button:ClearAllPoints()
				G.UnitFrames.Focus.Castbar.button:SetPoint( "LEFT", G.UnitFrames.Focus.Castbar, "RIGHT", 5, 0 )
				G.UnitFrames.Focus.Castbar.button:Size( 23 )
				G.UnitFrames.Focus.Castbar.button:CreateShadow( "Default" )
			else
				G.UnitFrames.Focus.Castbar:Width( 215 )

				G.UnitFrames.Focus.Castbar.button:Kill()
			end
		end
	end
	
	------------------------------
	-- Buffs and debuffs.
	------------------------------
	do
		G.UnitFrames.Focus.Debuffs:Kill() -- Derp. ;p
	end
	
	------------------------------
	-- size
	------------------------------
	do
		G.UnitFrames.Focus:Size( 215, 27 )
	end
end

------------------------------
-- Focus Target
------------------------------
do
	------------------------------
	-- not needed
	------------------------------
	do
		G.UnitFrames.FocusTarget:SetBackdrop( nil )
		G.UnitFrames.FocusTarget:SetBackdropColor( 0, 0, 0 )
		G.UnitFrames.FocusTarget.shadow:Kill()
	end

	------------------------------
	-- health
	------------------------------
	do
		G.UnitFrames.FocusTarget.Health:Size( 215, 27 )
		G.UnitFrames.FocusTarget.Health:SetFrameLevel( 5 )
		G.UnitFrames.FocusTarget.Health:CreateBorder(false, true)
		G.UnitFrames.FocusTarget.Health.bg:SetTexture(.6, .5, .5)
		
		--Border for the health bar.
				local healthBG = CreateFrame("Frame", healthBG, G.UnitFrames.FocusTarget.Health)
				healthBG:ClearAllPoints()
				healthBG:SetPoint("TOPLEFT", -2, 2)
				healthBG:SetPoint("BOTTOMRIGHT", 2, -2)
				healthBG:Size(1, 1)
				healthBG:SetTemplate("Default")
				healthBG:CreateBorder(true, true)
				healthBG:SetFrameStrata("Low")
				healthBG:SetFrameLevel(G.UnitFrames.TargetTarget.Health:GetFrameLevel())
				healthBG:CreateShadow("Default")

		if( C["unitframes"]["unicolor"] == true ) then
			G.UnitFrames.FocusTarget.Health.colorTapping = false
			G.UnitFrames.FocusTarget.Health.colorDisconnected = false
			G.UnitFrames.FocusTarget.Health.colorClass = false
			G.UnitFrames.FocusTarget.Health:SetStatusBarColor( 0.12, 0.12, 0.12, 1 )
			G.UnitFrames.FocusTarget.Health.bg:SetVertexColor( 0.6, 0.3, 0.3, 1 )
		else
			G.UnitFrames.FocusTarget.Health.bg:SetVertexColor( .05, .05, .05, 1 )
			G.UnitFrames.FocusTarget.Health.colorDisconnected = true
			G.UnitFrames.FocusTarget.Health.colorTapping = true
			G.UnitFrames.FocusTarget.Health.colorClass = true
			G.UnitFrames.FocusTarget.Health.colorReaction = true
		end

		G.UnitFrames.FocusTarget.Name:SetFont(T.CreateFontString() )
		G.UnitFrames.FocusTarget.Name:SetShadowOffset( 0, 0 )
		G.UnitFrames.FocusTarget.Name:Point( "CENTER", G.UnitFrames.FocusTarget.Health, "CENTER", 0, 1 )

		G.UnitFrames.FocusTarget.Health.value = T.SetFontString( G.UnitFrames.FocusTarget.Health, T.CreateFontString())
		G.UnitFrames.FocusTarget.Health.value:Point( "RIGHT", G.UnitFrames.FocusTarget.Health, "RIGHT", -4, 1 )
		G.UnitFrames.FocusTarget.Health.value:SetShadowOffset(0, 0)
		
	end

	------------------------------
	-- power
	------------------------------
	do
		G.UnitFrames.FocusTarget.Power:Size( 215, 27 )
		G.UnitFrames.FocusTarget.Power:ClearAllPoints()
		G.UnitFrames.FocusTarget.Power:Point( "BOTTOMRIGHT", G.UnitFrames.FocusTarget.Health, "BOTTOMRIGHT", 6, -6 )
		G.UnitFrames.FocusTarget.Power:CreateBorder(false, true)
		G.UnitFrames.FocusTarget.Power:SetFrameStrata("Low")
		
		--Border for the powerbar.
				local powerBG = CreateFrame("Frame", powerBG, G.UnitFrames.FocusTarget.Power)
				powerBG:ClearAllPoints()
				powerBG:SetPoint("TOPLEFT", -2, 2)
				powerBG:SetPoint("BOTTOMRIGHT", 2, -2)
				powerBG:Size(1, 1)
				powerBG:SetTemplate("Default")
				powerBG:CreateBorder(true, true)
				powerBG:SetFrameStrata("Background")
				powerBG:SetFrameLevel(G.UnitFrames.Player.Power:GetFrameLevel())
				powerBG:CreateShadow("Default")

		G.UnitFrames.FocusTarget.Power.value = T.SetFontString( G.UnitFrames.FocusTarget.Health, T.CreateFontString())
		G.UnitFrames.FocusTarget.Power.value:Point( "LEFT", G.UnitFrames.FocusTarget.Health, "LEFT", 4, 1 )
		
		G.UnitFrames.FocusTarget.Power.value:SetShadowOffset(0, 0)
	end


	------------------------------
	-- castbar
	------------------------------
	do
		if( C["unitframes"]["unitcastbar"] == true ) then
			G.UnitFrames.FocusTarget.Castbar:ClearAllPoints()
			G.UnitFrames.FocusTarget.Castbar:SetHeight( 19 )
			G.UnitFrames.FocusTarget.Castbar:Point( "TOPLEFT", G.UnitFrames.FocusTarget.Power, "BOTTOMLEFT", 0, -7)
			G.UnitFrames.FocusTarget.Castbar:CreateBorder(false, true)
			
			--Border for the castbar.
				local castBG = CreateFrame("Frame", castBG, G.UnitFrames.FocusTarget.Castbar)
				castBG:ClearAllPoints()
				castBG:SetPoint("TOPLEFT", -2, 2)
				castBG:SetPoint("BOTTOMRIGHT", 2, -2)
				castBG:Size(1, 1)
				castBG:SetTemplate("Default")
				castBG:CreateBorder(true, true)
				castBG:SetFrameStrata("Background")
				castBG:CreateShadow("Default")

			G.UnitFrames.FocusTarget.Castbar.bg:Kill()

			G.UnitFrames.FocusTarget.Castbar.bg = G.UnitFrames.FocusTarget.Castbar:CreateTexture( nil, "BORDER" )
			G.UnitFrames.FocusTarget.Castbar.bg:SetAllPoints( G.UnitFrames.FocusTarget.Castbar )
			G.UnitFrames.FocusTarget.Castbar.bg:SetTexture( C["media"]["normTex"] )
			G.UnitFrames.FocusTarget.Castbar.bg:SetVertexColor( .05, .05, .05, .5 )

			G.UnitFrames.FocusTarget.Castbar.Time = T.SetFontString( G.UnitFrames.FocusTarget.Castbar, T.CreateFontString() )
			G.UnitFrames.FocusTarget.Castbar.Time:Point( "RIGHT", G.UnitFrames.FocusTarget.Castbar, "RIGHT", -4, 1 )
			G.UnitFrames.FocusTarget.Castbar.Time:SetTextColor( 1, 1, 1 )
			G.UnitFrames.FocusTarget.Castbar.Time:SetShadowOffset(0, 0)

			G.UnitFrames.FocusTarget.Castbar.Text = T.SetFontString( G.UnitFrames.FocusTarget.Castbar, T.CreateFontString() )
			G.UnitFrames.FocusTarget.Castbar.Text:Point( "LEFT", G.UnitFrames.FocusTarget.Castbar, "LEFT", 4, 1 )
			G.UnitFrames.FocusTarget.Castbar.Text:SetTextColor( 1, 1, 1 )
			G.UnitFrames.FocusTarget.Castbar.Text:SetShadowOffset(0, 0)

			G.UnitFrames.FocusTarget.Castbar.PostCastStart = T.PostCastStart
			G.UnitFrames.FocusTarget.Castbar.PostChannelStart = T.PostCastStart

			if( C["unitframes"]["cbicons"] == true ) then
				G.UnitFrames.FocusTarget.Castbar:Width( 215 - 26 )

				G.UnitFrames.FocusTarget.Castbar.button:ClearAllPoints()
				G.UnitFrames.FocusTarget.Castbar.button:SetPoint( "LEFT", G.UnitFrames.FocusTarget.Castbar, "RIGHT", 5, 0 )
				G.UnitFrames.FocusTarget.Castbar.button:Size( 23 )
				G.UnitFrames.FocusTarget.Castbar.button:CreateShadow( "Default" )
			else
				G.UnitFrames.FocusTarget.Castbar:Width( 215 )

				G.UnitFrames.FocusTarget.Castbar.button:Kill()
			end
		end
	end
	
	------------------------------
	-- Buffs and debuffs.
	------------------------------
	do
		G.UnitFrames.FocusTarget.Debuffs:Kill() -- Derp. ;p
	end

	------------------------------
	-- Kill buffs and debuffs.
	------------------------------
	
	G.UnitFrames.FocusTarget.Debuffs:Kill()
	
	------------------------------
	-- size
	------------------------------
	do
		G.UnitFrames.FocusTarget:Size( 215, 27 )
	end
end

------------------------------
-- Boss
------------------------------
do
	for i = 1, MAX_BOSS_FRAMES do
		------------------------------
		-- not needed
		------------------------------
		do
			G.UnitFrames["Boss" .. i]:SetBackdrop( nil )
			G.UnitFrames["Boss" .. i]:SetBackdropColor( 0, 0, 0 )
			G.UnitFrames["Boss" .. i].shadow:Kill()
		end

		------------------------------
		-- health
		------------------------------
		do
			G.UnitFrames["Boss" .. i].Health:Size( 215, 27 )
			G.UnitFrames["Boss" .. i].Health:SetFrameLevel( 5 )
			G.UnitFrames["Boss" .. i].Health:CreateBorder(false, true)
			G.UnitFrames["Boss" .. i].Health.bg:SetTexture(.6, .5, .5)
			
			--Border for the health bar.
				local healthBG = CreateFrame("Frame", healthBG, G.UnitFrames["Boss" .. i])
				healthBG:ClearAllPoints()
				healthBG:SetPoint("TOPLEFT", -2, 2)
				healthBG:SetPoint("BOTTOMRIGHT", 2, -2)
				healthBG:Size(1, 1)
				healthBG:SetTemplate("Default")
				healthBG:CreateBorder(true, true)
				healthBG:SetFrameStrata("Low")
				healthBG:SetFrameLevel(G.UnitFrames.TargetTarget.Health:GetFrameLevel())
				healthBG:CreateShadow("Default")

			if( C["unitframes"]["unicolor"] == true ) then
				G.UnitFrames["Boss" .. i].Health.colorTapping = false
				G.UnitFrames["Boss" .. i].Health.colorDisconnected = false
				G.UnitFrames["Boss" .. i].Health.colorClass = false
				G.UnitFrames["Boss" .. i].Health:SetStatusBarColor( 0.12, 0.12, 0.12, 1 )
				G.UnitFrames["Boss" .. i].Health.bg:SetVertexColor( 0.6, 0.3, 0.3, 1 )
			else
				G.UnitFrames["Boss" .. i].Health.bg:SetVertexColor( .05, .05, .05, 1 )
				G.UnitFrames["Boss" .. i].Health.colorDisconnected = true
				G.UnitFrames["Boss" .. i].Health.colorTapping = true
				G.UnitFrames["Boss" .. i].Health.colorClass = true
				G.UnitFrames["Boss" .. i].Health.colorReaction = true
			end

			G.UnitFrames["Boss" .. i].Name:SetFont(T.CreateFontString() )
			G.UnitFrames["Boss" .. i].Name:Point( "CENTER", G.UnitFrames["Boss" .. i].Health, "CENTER", 0, 1 )
			G.UnitFrames["Boss" .. i].Name:SetShadowOffset(0, 0)

			G.UnitFrames["Boss" .. i].Health.value = T.SetFontString( G.UnitFrames["Boss" .. i].Health, T.CreateFontString())
			G.UnitFrames["Boss" .. i].Health.value:Point( "RIGHT", G.UnitFrames["Boss" .. i].Health, "RIGHT", -4, 1 )
			G.UnitFrames["Boss"..i].Health.value:SetShadowOffset(0, 0)
		end
		
	------------------------------
	-- Buffs and debuffs.
	------------------------------
	do
		G.UnitFrames["Boss"..i].Debuffs:Kill() -- Derp. ;p
		G.UnitFrames["Boss"..i].Buffs:Kill() -- Derp. ;p
	end

		------------------------------
		-- power
		------------------------------
		do
			G.UnitFrames["Boss" .. i].Power:Size( 215, 27 )
			G.UnitFrames["Boss" .. i].Power:ClearAllPoints()
			G.UnitFrames["Boss" .. i].Power:Point( "BOTTOMLEFT", G.UnitFrames["Boss" .. i].Health, "BOTTOMLEFT", -6, -6 )
			G.UnitFrames["Boss" .. i].Power:CreateBorder(false, true)
			G.UnitFrames["Boss" .. i].Power:SetFrameStrata("Low")
			
			--Border for the powerbar.
				local powerBG = CreateFrame("Frame", powerBG,G.UnitFrames["Boss" .. i].Power)
				powerBG:ClearAllPoints()
				powerBG:SetPoint("TOPLEFT", -2, 2)
				powerBG:SetPoint("BOTTOMRIGHT", 2, -2)
				powerBG:Size(1, 1)
				powerBG:SetTemplate("Default")
				powerBG:CreateBorder(true, true)
				powerBG:SetFrameStrata("Background")
				powerBG:SetFrameLevel(G.UnitFrames.Player.Power:GetFrameLevel())
				powerBG:CreateShadow("Default")

			G.UnitFrames["Boss" .. i].Power.value = T.SetFontString( G.UnitFrames["Boss" .. i].Health, T.CreateFontString())
			G.UnitFrames["Boss" .. i].Power.value:Point( "LEFT", G.UnitFrames["Boss" .. i].Health, "LEFT", 4, 1 )
			G.UnitFrames["Boss"..i].Power.value:SetShadowOffset(0,0)
		end
		

		------------------------------
		-- castbar
		------------------------------
		do
			if( C["unitframes"]["unitcastbar"] == true ) then
				G.UnitFrames["Boss" .. i].Castbar:ClearAllPoints()
				G.UnitFrames["Boss" .. i].Castbar:SetHeight( 19 )
				G.UnitFrames["Boss" .. i].Castbar:Point( "TOPRIGHT", G.UnitFrames["Boss" .. i].Power, "BOTTOMRIGHT", 0, -7 )
				G.UnitFrames["Boss" .. i].Castbar:CreateBorder(false, true)

				--Border for the castbar.
				local castBG = CreateFrame("Frame", castBG, G.UnitFrames["Boss" .. i].Castbar)
				castBG:ClearAllPoints()
				castBG:SetPoint("TOPLEFT", -2, 2)
				castBG:SetPoint("BOTTOMRIGHT", 2, -2)
				castBG:Size(1, 1)
				castBG:SetTemplate("Default")
				castBG:CreateBorder(true, true)
				castBG:SetFrameStrata("Background")
				castBG:CreateShadow("Default")
				
				G.UnitFrames["Boss" .. i].Castbar.bg:Kill()

				G.UnitFrames["Boss" .. i].Castbar.bg = G.UnitFrames["Boss" .. i].Castbar:CreateTexture( nil, "BORDER" )
				G.UnitFrames["Boss" .. i].Castbar.bg:SetAllPoints( G.UnitFrames["Boss" .. i].Castbar )
				G.UnitFrames["Boss" .. i].Castbar.bg:SetTexture( C["media"]["normTex"] )
				G.UnitFrames["Boss" .. i].Castbar.bg:SetVertexColor( 0.05, 0.05, 0.05 )

				G.UnitFrames["Boss" .. i].Castbar.Time = T.SetFontString( G.UnitFrames["Boss" .. i].Castbar, T.CreateFontString())
				G.UnitFrames["Boss" .. i].Castbar.Time:Point( "RIGHT", G.UnitFrames["Boss" .. i].Castbar, "RIGHT", -4, 1 )
				G.UnitFrames["Boss" .. i].Castbar.Time:SetTextColor( 1, 1, 1 )
				G.UnitFrames["Boss" .. i].Castbar.Time:SetShadowOffset(0, 0)

				G.UnitFrames["Boss" .. i].Castbar.Text = T.SetFontString( G.UnitFrames["Boss" .. i].Castbar, T.CreateFontString())
				G.UnitFrames["Boss" .. i].Castbar.Text:Point( "LEFT", G.UnitFrames["Boss" .. i].Castbar, "LEFT", 4, 1 )
				G.UnitFrames["Boss" .. i].Castbar.Text:SetTextColor( 1, 1, 1 )
				G.UnitFrames["Boss" .. i].Castbar.Text:SetShadowOffset(0, 0)

				G.UnitFrames["Boss" .. i].Castbar.PostCastStart = T.PostCastStart
				G.UnitFrames["Boss" .. i].Castbar.PostChannelStart = T.PostCastStart

				if( C["unitframes"]["cbicons"] == true ) then
					G.UnitFrames["Boss" .. i].Castbar:Width( 215 - 26 )

					G.UnitFrames["Boss" .. i].Castbar.button:ClearAllPoints()
					G.UnitFrames["Boss" .. i].Castbar.button:SetPoint( "RIGHT", G.UnitFrames["Boss" .. i].Castbar, "LEFT", -5, 0 )
					G.UnitFrames["Boss" .. i].Castbar.button:Size( 23 )
					G.UnitFrames["Boss" .. i].Castbar.button:CreateShadow( "Default" )
				else
					G.UnitFrames["Boss" .. i].Castbar:Width( 215 )

					G.UnitFrames["Boss" .. i].Castbar.button:Kill()
				end
			end
		end

		-- Buffs/debuffs.
		do
		G.UnitFrames["Boss" .. i].Buffs:Kill()
		G.UnitFrames["Boss" .. i].Debuffs:Kill()
		end
		
		------------------------------
		-- altpowerbar
		------------------------------
		do
			G.UnitFrames["Boss" .. i].AltPowerBar:SetStatusBarTexture( C["media"]["normal"] )
		end

		------------------------------
		-- size
		------------------------------
		do
			G.UnitFrames["Boss" .. i]:Size( 215, 27 )
		end
	end
end

------------------------------
-- Arena
------------------------------
do
	for i = 1, 5 do
		------------------------------
		-- not needed
		------------------------------
		do
			G.UnitFrames["Arena" .. i]:SetBackdrop( nil )
			G.UnitFrames["Arena" .. i]:SetBackdropColor( 0, 0, 0 )
			G.UnitFrames["Arena" .. i].shadow:Kill()
		end

		------------------------------
		-- health
		------------------------------
		do
			G.UnitFrames["Arena" .. i].Health:Size( 215, 27 )
			G.UnitFrames["Arena" .. i].Health:SetFrameLevel( 5 )
			G.UnitFrames["Arena" .. i].Health:CreateBorder(false, true)
			G.UnitFrames["Arena" .. i].Health.bg:SetTexture(.6, .5, .5)

			if( C["unitframes"]["unicolor"] == true ) then
				G.UnitFrames["Arena" .. i].Health.colorTapping = false
				G.UnitFrames["Arena" .. i].Health.colorDisconnected = false
				G.UnitFrames["Arena" .. i].Health.colorClass = false
				G.UnitFrames["Arena" .. i].Health:SetStatusBarColor( 0.12, 0.12, 0.12, 1 )
				G.UnitFrames["Arena" .. i].Health.bg:SetVertexColor( .6, .3, .3, 1 )
			else
				G.UnitFrames["Arena" .. i].Health.bg:SetVertexColor( .05, .05, .05, 1 )
				G.UnitFrames["Arena" .. i].Health.colorDisconnected = true
				G.UnitFrames["Arena" .. i].Health.colorTapping = true
				G.UnitFrames["Arena" .. i].Health.colorClass = true
				G.UnitFrames["Arena" .. i].Health.colorReaction = true
			end

			G.UnitFrames["Arena" .. i].Name:SetFont(T.CreateFontString() )
			G.UnitFrames["Arena" .. i].Name:SetShadowOffset( 0, 0 )
			G.UnitFrames["Arena" .. i].Name:Point( "CENTER", G.UnitFrames["Arena" .. i].Health, "CENTER", 0, 1 )

			G.UnitFrames["Arena" .. i].Health.value = T.SetFontString( G.UnitFrames["Arena" .. i].Health, T.CreateFontString())
			G.UnitFrames["Arena" .. i].Health.value:Point( "RIGHT", G.UnitFrames["Arena" .. i].Health, "RIGHT", -4, 1 )
			G.UnitFrames["Arena" .. i].Health.value:SetShadowOffset(0, 0)
			
			--Border for the health bar.
				local healthBG = CreateFrame("Frame", healthBG, G.UnitFrames["Arena" .. i])
				healthBG:ClearAllPoints()
				healthBG:SetPoint("TOPLEFT", -2, 2)
				healthBG:SetPoint("BOTTOMRIGHT", 2, -2)
				healthBG:Size(1, 1)
				healthBG:SetTemplate("Default")
				healthBG:CreateBorder(true, true)
				healthBG:SetFrameStrata("MEDIUM")
				healthBG:SetFrameLevel(G.UnitFrames.TargetTarget.Health:GetFrameLevel())
				healthBG:CreateShadow("Default")
		end

		------------------------------
		-- power
		------------------------------
		do
			G.UnitFrames["Arena" .. i].Power:Size( 215, 27 )
			G.UnitFrames["Arena" .. i].Power:ClearAllPoints()
			G.UnitFrames["Arena" .. i].Power:Point( "BOTTOMRIGHT", G.UnitFrames["Arena" .. i].Health, "BOTTOMRIGHT", -6, -6 )
			G.UnitFrames["Arena" .. i].Power:CreateBorder(false, true)

			G.UnitFrames["Arena" .. i].Power.value = T.SetFontString( G.UnitFrames["Arena" .. i].Health, T.CreateFontString())
			G.UnitFrames["Arena" .. i].Power.value:Point( "LEFT", G.UnitFrames["Arena" .. i].Health, "LEFT", 4, 1 )
			G.UnitFrames["Arena" .. i].Power.value:SetShadowOffset(0, 0)
			
			--Border for the powerbar.
				local powerBG = CreateFrame("Frame", powerBG,G.UnitFrames["Arena" .. i].Power)
				powerBG:ClearAllPoints()
				powerBG:SetPoint("TOPLEFT", -2, 2)
				powerBG:SetPoint("BOTTOMRIGHT", 2, -2)
				powerBG:Size(1, 1)
				powerBG:SetTemplate("Default")
				powerBG:CreateBorder(true, true)
				powerBG:SetFrameStrata("Background")
				powerBG:SetFrameLevel(G.UnitFrames.Player.Power:GetFrameLevel())
				powerBG:CreateShadow("Default")
		end

		------------------------------
		-- castbar
		------------------------------
		do
			if( C["unitframes"]["unitcastbar"] == true ) then
				G.UnitFrames["Arena" .. i].Castbar:ClearAllPoints()
				G.UnitFrames["Arena" .. i].Castbar:SetHeight( 19 )
				G.UnitFrames["Arena" .. i].Castbar:Point( "TOPRIGHT", G.UnitFrames["Arena" .. i].Power, "BOTTOMRIGHT", 0, -7 )
				G.UnitFrames["Arena" .. i].Castbar:CreateBorder(false, true)

				G.UnitFrames["Arena" .. i].Castbar.bg:Kill()

				G.UnitFrames["Arena" .. i].Castbar.bg = G.UnitFrames["Arena" .. i].Castbar:CreateTexture( nil, "BORDER" )
				G.UnitFrames["Arena" .. i].Castbar.bg:SetAllPoints( G.UnitFrames["Arena" .. i].Castbar )
				G.UnitFrames["Arena" .. i].Castbar.bg:SetTexture( C["media"]["normTex"] )
				G.UnitFrames["Arena" .. i].Castbar.bg:SetVertexColor( 0.05, 0.05, 0.05 )

				G.UnitFrames["Arena" .. i].Castbar.Time = T.SetFontString( G.UnitFrames["Arena" .. i].Castbar, T.CreateFontString())
				G.UnitFrames["Arena" .. i].Castbar.Time:Point( "RIGHT", G.UnitFrames["Arena" .. i].Castbar, "RIGHT", -4, 1 )
				G.UnitFrames["Arena" .. i].Castbar.Time:SetTextColor( 0, 4, 0 )

				G.UnitFrames["Arena" .. i].Castbar.Text = T.SetFontString( G.UnitFrames["Arena" .. i].Castbar, T.CreateFontString())
				G.UnitFrames["Arena" .. i].Castbar.Text:Point( "LEFT", G.UnitFrames["Arena" .. i].Castbar, "LEFT", 4, 1 )
				G.UnitFrames["Arena" .. i].Castbar.Text:SetTextColor( 0.3, 0.2, 1 )

				G.UnitFrames["Arena" .. i].Castbar.PostCastStart = T.PostCastStart
				G.UnitFrames["Arena" .. i].Castbar.PostChannelStart = T.PostCastStart
				
				--Border for the castbar.
				local castBG = CreateFrame("Frame", castBG, G.UnitFrames["Arena" .. i].Castbar)
				castBG:ClearAllPoints()
				castBG:SetPoint("TOPLEFT", -2, 2)
				castBG:SetPoint("BOTTOMRIGHT", 2, -2)
				castBG:Size(1, 1)
				castBG:SetTemplate("Default")
				castBG:CreateBorder(true, true)
				castBG:SetFrameStrata("Background")
				castBG:CreateShadow("Default")

				if( C["unitframes"]["cbicons"] == true ) then
					G.UnitFrames["Arena" .. i].Castbar:Width( 215 - 26 )

					G.UnitFrames["Arena" .. i].Castbar.button:ClearAllPoints()
					G.UnitFrames["Arena" .. i].Castbar.button:SetPoint( "RIGHT", G.UnitFrames["Arena" .. i].Castbar, "LEFT", -5, 0 )
					G.UnitFrames["Arena" .. i].Castbar.button:Size( 23 )
					G.UnitFrames["Arena" .. i].Castbar.button:CreateShadow( "Default" )
				else
					G.UnitFrames["Arena" .. i].Castbar:Width( 215 )

					G.UnitFrames["Arena" .. i].Castbar.button:Kill()
				end
			end
		end

		------------------------------
		-- Buffs and debuffs.
		------------------------------
		do
			G.UnitFrames["Arena"..i].Debuffs:Kill() -- Derp. ;p
			G.UnitFrames["Arena"..i].PVPSpecIcon:Kill() -- Derp. ;p
		end

		------------------------------
		-- size
		------------------------------
		do
			G.UnitFrames["Arena" .. i]:Size( 215, 27 )
		end
	end
end

------------------------------
-- Main Tank, Main Assist
------------------------------
do

end

------------------------------
-- Position
------------------------------
local FramePositions = CreateFrame( "Frame" )
FramePositions:RegisterEvent( "PLAYER_ENTERING_WORLD" )
FramePositions:SetScript( "OnEvent", function( self, event, addon )
	G.UnitFrames.Player:ClearAllPoints()
	G.UnitFrames.Target:ClearAllPoints()
	G.UnitFrames.TargetTarget:ClearAllPoints()
	G.UnitFrames.Pet:ClearAllPoints()
	G.UnitFrames.Focus:ClearAllPoints()
	G.UnitFrames.FocusTarget:ClearAllPoints()
	
	
	-- Just move them in a bit if the charportrait is enabled and integrated is set to false.
	if C.unitframes.charportrait == true and C.unitframes.integrateportrait == false then
		G.UnitFrames.Player:SetPoint( "BOTTOMLEFT", TukuiBar1, "TOPLEFT", -127, 37 )
		G.UnitFrames.Target:SetPoint( "BOTTOMRIGHT", TukuiBar1, "TOPRIGHT", 127, 37 )
	else
		G.UnitFrames.Player:SetPoint( "BOTTOMLEFT", TukuiBar1, "TOPLEFT", -194, 37 )
		G.UnitFrames.Target:SetPoint( "BOTTOMRIGHT", TukuiBar1, "TOPRIGHT", 194, 37 )
	end

	G.UnitFrames.TargetTarget:SetPoint( "BOTTOM", TukuiBar1, "TOP", 0, 45 )
	G.UnitFrames.Pet:SetPoint( "BOTTOM", G.UnitFrames.TargetTarget, "TOP", 0, 21 )
	G.UnitFrames.Focus:SetPoint( "BOTTOM", UIParent, "BOTTOM", -400, 400)
	G.UnitFrames.FocusTarget:SetPoint( "BOTTOM", G.UnitFrames.Focus, "TOP", 0 , 43)
	

	for i = 1, MAX_BOSS_FRAMES do
		G.UnitFrames["Boss" .. i]:ClearAllPoints()
		if( i == 1 ) then
			G.UnitFrames["Boss" .. i]:SetPoint( "BOTTOM", UIParent, "BOTTOM", 400, 400 )
		else
			G.UnitFrames["Boss" .. i]:SetPoint( "BOTTOM", G.UnitFrames["Boss" .. i - 1], "TOP", 0, 43 )
		end
	end

	for i = 1, 5 do
		G.UnitFrames["Arena" .. i]:ClearAllPoints()
		if( i == 1 ) then
			G.UnitFrames["Arena" .. i]:SetPoint( "BOTTOM", UIParent, "BOTTOM", 400, 400 )
		else
			G.UnitFrames["Arena" .. i]:SetPoint( "BOTTOM", G.UnitFrames["Arena" .. i - 1], "TOP", 0, 43 )
		end
	end
	
end )