local T, C, L, G = unpack(Tukui)

-- Move the name.
hooksecurefunc( T, "PostNamePosition", function( self )
	self.Name:ClearAllPoints()
	
	if( self.Power.value:GetText() and UnitIsEnemy( "player", "target" ) and C["unitframes"]["targetpowerpvponly"] == true ) or ( self.Power.value:GetText() and C["unitframes"]["targetpowerpvponly"] == false ) then
		self.Name:SetPoint( "CENTER", self.Health, "CENTER", 0, 1 )
	else
		self.Name:SetPoint( "CENTER", self.Health, "CENTER", 0, 1 )
	end
end )

-- Set the color to the castbar.
T.PostCastStart = function( self, unit, name, rank, castid )
if( unit == "vehicle" ) then unit = "player" end

if( name == "Opening" ) then
	self.Text:SetText( "Opening" )
end
	
self:SetStatusBarColor( unpack( oUFTukui.colors.class[select( 2, UnitClass( unit ) ) ] ) )
	
local color
self.unit = unit
end

T.CreatePopup["FLYINGUI_SELECT_RAID_LAYOUT"] = {
	question = L.Popups_SELECT_RAID_LAYOUT,
	answer1 = "DPS, Tank",
	answer2 = "Healing",
	function1 = function()
		DisableAddOn( "FlyingUI_Raid_Healing" )
		EnableAddOn( "FlyingUI_Raid" )
		ReloadUI()
	end,
	function2 = function()
		EnableAddOn( "FlyingUI_Raid_Healing" )
		DisableAddOn( "FlyingUI_Raid" )
		ReloadUI()
	end,
}

local FlyingUIOnLogon = CreateFrame( "Frame" )
FlyingUIOnLogon:RegisterEvent( "PLAYER_ENTERING_WORLD" )
FlyingUIOnLogon:SetScript( "OnEvent", function( self, event )
	self:UnregisterEvent( "PLAYER_ENTERING_WORLD" )

	if( IsAddOnLoaded( "FlyingUI_Raid" ) and IsAddOnLoaded( "FlyingUI_Raid_Healing" ) ) then
		T.ShowPopup( "FLYINGUI_SELECT_RAID_LAYOUT" )
	end
end )