local T, C, L = unpack(Tukui)

TukuiMinimap:ClearAllPoints()
TukuiMinimap:SetPoint("TOPRIGHT", UIParent, "TOPRIGHT", -2, -2)
TukuiMinimap:CreateBorder(true, true)
TukuiMinimap:CreateShadow("Default")

-- Zone coordinates on hovering minimap.
TukuiMinimapCoord:SetTemplate("Transparent")
TukuiMinimapCoord:ClearAllPoints()
TukuiMinimapCoord:SetPoint("BOTTOM", TukuiMinimap, "BOTTOM", 0, 14)
TukuiMinimapCoordText:SetFont(T.CreateFontString())

-- Zone text when hovering minimap.
TukuiMinimapZone:SetTemplate("Transparent")
TukuiMinimapZone:CreateShadow("Default")
TukuiMinimapZoneText:SetFont(T.CreateFontString()) -- So sexeh.

-- Skin the ticket panel.
TukuiTicket:SetTemplate("Transparent")
TukuiTicket:CreateShadow("Default")
TukuiTicket:Size(23)
TukuiTicket.Text:SetText(T.RGBToHex(unpack(C.media.datatextcolor1)).."T")
TukuiTicket.Text:SetFont(T.CreateFontString())
TukuiTicket:ClearAllPoints()
TukuiTicket:SetPoint("BOTTOMLEFT", TukuiMinimap, "BOTTOMLEFT", 4, 4)

