local C = {}
local class = RAID_CLASS_COLORS[select(2,UnitClass("player"))] -- Do not remove this line, it is what is required to add class color for the datatext.

C.general = {
	overridelowtohigh = false, -- If you wish to use the high resolution layout as low resolution user, set this to true.
	uiscale = .71, -- Changes the UIScale of the UI.
	backdropcolor = { 0.05,0.05,0.05 }, -- Color of the panels.
	bordercolor = { .1, .1, .1 }, -- Color of the border.
	pixelfont = true,  -- Changes the font from normal font to Pixelfont.
}

C.media = {
	datatextcolor1 = {class.r, class.g, class.b}, -- Color of the first set of datatext.
	datatextcolor2 = {1, 1, 1}, -- Color of the second set of datatext.
}

C.unitframes = {
	combatfeedback = false, -- Shows how much damage the player and target takes per hit.
	targetpowerpvponly = false, -- Set this to true to only see power on PvP marked targets.
	unicolor = true, -- Sets all health bar to grey and power bars to class color, set to false for class coloured health bars.
	gridonly = true, -- Sets so whatever raid size you are in, it shows as grid. Only works on heal layout.
	showplayerinparty = true, -- Do I really need to explain this one?
	charportrait = false, -- Herp derp?
	integrateportrait = false, -- Sets the portrait on the healthbar instead of on the side.
	mushroombar == false, -- Mushroombar...?
	onlyselfdebuffs = false, -- Shows only your own debuffs on the target.
	cbicons = true, -- Disables or enables the castbar icon.
}

C.datatext = {
	armor = 0,  -- Displays how much armor you have.
	avd = 0,  -- How much avoidance you have.
	bags = 1,  -- How much free/full space you have in your bags.
	calltoarms = 0,  -- Pretty self explanatory.
	crit = 10, -- How much crit you have.
	currency = 2,  -- JP/VP/CP display.
	dps_text = 0,  -- A personal DPS meter.
	dur = 3,  -- How much % your armor is at.
	fps_ms = 4, -- Displays FPS and MS.
	friends = 0, -- How many friends are online.
	gold = 6, -- How much gold you have.
	guild = 0, -- How many guild members are online.
	haste = 0, -- How much haste you have.
	hit = 0, -- How much hit you have.
	hps_text = 0, -- Personal HPS meter.
	mastery = 11,  -- How much mastery you have.
	micromenu = 0, -- Click it for a small menu to popup.
	power = 0, -- How much attack power you have.
	regen = 0, -- How much power regeneration you have.
	system = 5,  -- How much your AddOn folder is.
	talent = 0, -- Press it to swap talents from main spec to off spec.
	wowtime = 8, -- Displays time.
	
	
	battleground = true, -- Battleground stats, such as Killing Blows, Damage and Deaths.
	time24 = true, -- Display time to up to 24 hours instead of 12.
	localtime = true, -- Display your local time and not server time.
	fontsize = 12, -- Size of datatext font.
}

C.actionbar = {
	buttonsize = 27, -- Size of the actionbars buttons.
	petbuttonsize = 27, -- Size of the petbar buttons.
}

C.nameplate = {
	showhealth = true, -- Shows the health on the nameplates.
	enhancethreat = true, -- Colors the nameplates after threat.
}

C.auras = {
	consolidate = false, -- Deactivates consolidate buffs so you can see all your buffs.
	classictimer = false, -- Sets a font instead of a green bar to track the duration of buffs.
}

C.chat = {
	background = true, -- Really?
}

-- Implements our config into Tukui.
TukuiEditedDefaultConfig = C